define("io.ox/office/presentation/utils/presentationutils",["io.ox/office/tk/utils","io.ox/office/editframework/utils/attributeutils","io.ox/office/textframework/utils/dom","gettext!io.ox/office/presentation/main"],function(a,b,c,d){"use strict";var e={};return e.PLACEHOLDER_DRAWING_IMPORTANT_ATTRS=["left","top","width","height","rotation","flipH","flipV"],e.DEFAULT_PLACEHOLDER_TYPE="body",e.TABLE_PLACEHOLDER_TYPE="tbl",e.IMAGE_PLACEHOLDER_TYPE="pic",e.CONTENTBODY="contentbody",e.TITLE_PLACEHOLDER_TYPES={title:1,ctrTitle:1},e.NO_TEXT_PLACEHOLDER_TYPE={media:1,clipArt:1,chart:1,dgm:1,tbl:1,pic:1},e.NO_TEXT_PLACEHOLDER_CONTENT_PROPERTY={media:null,clipArt:"image",chart:null,dgm:null,tbl:"table",pic:"image"},e.PLACEHOLDER_TEMPLATE_TEXTS={body:d("Click to add text"),title:d("Click to add title"),ctrTitle:d("Click to add title"),subTitle:d("Click to add subtitle"),media:d("Media clip"),clipArt:d("Online picture"),chart:d("Chart"),dgm:d("Smart Art"),tbl:d("Click to add table"),pic:d("Click to add picture"),sldNum:d("Slide Number"),ftr:d("Footer"),dt:d("Date")},e.PLACEHOLDER_TEMPLATE_TEXTS_CLICK={pic:d("Click icon to add picture"),tbl:d("Click icon to add table"),chart:d("Click icon to add chart"),dgm:d("Click icon to add smart art graphic"),clipArt:d("Click icon to add clip art"),media:d("Click icon to add media")},e.PLACEHOLDER_TEMPLATE_BUTTONS={contentBody:["picture","table"],body:null,title:null,ctrTitle:null,subTitle:null,media:["media"],clipArt:["clipart"],chart:["chart"],dgm:["smartart"],tbl:["table"],pic:["picture"],sldNum:null,ftr:null,dt:null},e.DEFAULT_PLACEHOLDER_INDEX=0,e.isPlaceHolderAttributeSet=function(a){return a&&a.presentation&&(a.presentation.phType||_.isNumber(a.presentation.phIndex))},e.isTitlePlaceHolderAttributeSet=function(a){return a&&a.presentation&&a.presentation.phType&&e.TITLE_PLACEHOLDER_TYPES[a.presentation.phType]},e.isBodyPlaceHolderAttributeSet=function(a){return a&&a.presentation&&_.isNumber(a.presentation.phIndex)&&(a.presentation.phType===e.DEFAULT_PLACEHOLDER_TYPE||!a.presentation.phType)},e.isTextBodyPlaceHolderAttributeSet=function(a){return a&&a.presentation&&_.isNumber(a.presentation.phIndex)&&a.presentation.phType===e.DEFAULT_PLACEHOLDER_TYPE},e.isContentBodyPlaceHolderAttributeSet=function(a){return a&&a.presentation&&_.isNumber(a.presentation.phIndex)&&!a.presentation.phType},e.isPlaceHolderWithoutTextAttributeSet=function(a){return a&&a.presentation&&a.presentation.phType&&e.NO_TEXT_PLACEHOLDER_TYPE[a.presentation.phType]},e.isCustomPromptPlaceHolderAttributeSet=function(a){return a&&a.presentation&&a.presentation.customPrompt},e.isPlaceHolderDrawing=function(a){return e.isPlaceHolderAttributeSet(b.getExplicitAttributes(a))},e.getPlaceHolderDrawingType=function(a,c){var d=c||b.getExplicitAttributes(a);return d&&d.presentation&&d.presentation.phType?d.presentation.phType:null},e.getPlaceHolderDrawingIndex=function(a,c){var d=c||b.getExplicitAttributes(a);return d&&d.presentation&&_.isNumber(d.presentation.phIndex)?d.presentation.phIndex:null},e.isTitlePlaceHolderDrawing=function(a){return e.isTitlePlaceHolderAttributeSet(b.getExplicitAttributes(a))},e.isBodyPlaceHolderDrawing=function(a){return e.isBodyPlaceHolderAttributeSet(b.getExplicitAttributes(a))},e.isTextBodyPlaceHolderDrawing=function(a){return e.isTextBodyPlaceHolderAttributeSet(b.getExplicitAttributes(a))},e.isContentBodyPlaceHolderDrawing=function(a){return e.isContentBodyPlaceHolderAttributeSet(b.getExplicitAttributes(a))},e.isPlaceHolderWithoutTextDrawing=function(a){return e.isPlaceHolderWithoutTextAttributeSet(b.getExplicitAttributes(a))},e.isEmptyPlaceHolderDrawing=function(a){var d=b.getExplicitAttributes(a),f=!1,g=null;return e.isPlaceHolderWithoutTextAttributeSet(d)?"undefined"!==$(a).attr("data-type")&&(g=e.NO_TEXT_PLACEHOLDER_CONTENT_PROPERTY[d.presentation.phType],d&&g&&d[g]||(f=!0)):e.isPlaceHolderAttributeSet(d)&&(f=c.isEmptyTextframe(a,{ignoreTemplateText:!0})),f},e.isCustomPromptPlaceHolderDrawing=function(a){return e.isCustomPromptPlaceHolderAttributeSet(b.getExplicitAttributes(a))},e.getDrawingModelDescriptor=function(d,f){var g=b.getExplicitAttributes(d),h=a.getBooleanOption(f,"useDefaultValues",!0),i=null;return e.isPlaceHolderAttributeSet(g)&&(i={},i.target=c.getTargetContainerId($(d).parent()),i.type=g.presentation.phType,i.index=g.presentation.phIndex,h&&(i.type&&!_.isNumber(i.index)&&(i.index=e.getDefaultPlaceHolderIndex()),_.isNumber(i.index)&&!i.type&&(i.type=e.getDefaultPlaceHolderType()))),i},e.getDefaultPlaceHolderType=function(){return e.DEFAULT_PLACEHOLDER_TYPE},e.getDefaultPlaceHolderIndex=function(){return e.DEFAULT_PLACEHOLDER_INDEX},e.getPlaceHolderTemplateText=function(a){var b=e.getPlaceHolderDrawingType(a);return!b&&_.isNumber(e.getPlaceHolderDrawingIndex(a))&&(b=e.getDefaultPlaceHolderType()),b?e.PLACEHOLDER_TEMPLATE_TEXTS[b]:null},e.getPlaceHolderTemplateButtonsList=function(a){return e.PLACEHOLDER_TEMPLATE_BUTTONS[a||"contentBody"]},e.convertAppContentBoxToOperationBox=function(b,c){var d=b.getView().getZoomFactor()/100,e=b.getModel().getSlideById(b.getModel().getActiveSlideId()),f=e.offset(),g=b.getView().getContentRootNode(),h=g.offset(),i=g.scrollLeft(),j=g.scrollTop(),k={};return k.left=a.round((c.left-(f.left-h.left)-i)/d,1),k.top=a.round((c.top-(f.top-h.top)-j)/d,1),k.width=a.round(c.width/d,1),k.height=a.round(c.height/d,1),k.left=a.convertLengthToHmm(k.left,"px"),k.top=a.convertLengthToHmm(k.top,"px"),k.width=a.convertLengthToHmm(k.width,"px"),k.height=a.convertLengthToHmm(k.height,"px"),k},e.extendPlaceholderProp=function(a,c,d){if(d&&d.attrs&&d.attrs.drawing){var f=b.getExplicitAttributes(c);if(e.isPlaceHolderAttributeSet(f)){var g=a.getModel().getDrawingStyles().getElementAttributes(c).drawing;_.each(g,function(a,b){b in d.attrs.drawing||!_.contains(e.PLACEHOLDER_DRAWING_IMPORTANT_ATTRS,b)||b in f.drawing||(d.attrs.drawing[b]=a)})}}},e});