define("io.ox/office/spreadsheet/model/formula/interpret/formulacompiler",["io.ox/office/tk/utils","io.ox/office/baseframework/model/modelobject","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens"],function(a,b,c,d,e){"use strict";function f(a,b){return _.isObject(a)&&a.isType("op")&&a.getValue()in m[b]}function g(a,b,c){this.token=a,this.operands=b||null,this.descriptor=c||null,this.recalc=null,this.relColRef=!1,this.relRowRef=!1,this.signature=null,this.error=null,this._initialize()}var h=c.ErrorCode,i=d.FormulaError,j=e.LiteralToken,k=e.OperatorToken,l=e.SheetRefToken,m={cmp:a.makeSet(["eq","ne","lt","le","gt","ge"]),con:a.makeSet(["con"]),pct:a.makeSet(["pct"]),add:a.makeSet(["add","sub"]),mul:a.makeSet(["mul","div"]),pow:a.makeSet(["pow"]),list:a.makeSet(["list"]),isect:a.makeSet(["isect"]),range:a.makeSet(["range"])};g.prototype._ensure=function(a,b,c){return a||(this.error=new i(b,c)),!!a},g.prototype._initialize=function(){switch(this.token.getType()){case"ref":return this.relColRef=this.token.hasRelCol(),void(this.relRowRef=this.token.hasRelRow());case"table":return void(this.relRowRef="ROW"===this.token.getRegionKey())}if(this.descriptor){this.recalc=this.descriptor.recalc;var b=this.operands?this.operands.length:0;this.relColRef=this.descriptor.relColRef?this.descriptor.relColRef(b):!1,this.relRowRef=this.descriptor.relRowRef?this.descriptor.relRowRef(b):!1}if(this.operands&&(this.recalc=this.operands.reduce(function(a,b){return d.getRecalcMode(a,b.recalc)},this.recalc),this.relColRef=this.relColRef||this.operands.some(function(a){return a.relColRef}),this.relRowRef=this.relRowRef||this.operands.some(function(a){return a.relRowRef})),this.operands&&this.descriptor){var c=this.descriptor.minParams,e=0,f=0;"maxParams"in this.descriptor?(e=this.descriptor.maxParams,f=1):(f="repeatParams"in this.descriptor?this.descriptor.repeatParams:1,e=c+a.roundDown(d.MAX_PARAM_COUNT-c,f));var g=this.operands.length;if(this._ensure(g>=c,"not enough parameters","missing")&&this._ensure(e>=g,"too many parameters","unexpected")&&this._ensure((g-c)%f===0,"not enough parameters","missing")){var h=this.descriptor.signature;(0===this.operands.length||h.length>0)&&(this.signature=_.times(this.operands.length,function(a){return h.length<=a&&(a=h.length-f+(a-h.length)%f),h[a]}))}}},g.prototype.isOperator=function(){return!!this.operands},g.prototype.toString=function(){return this.token+(this.isOperator()?":"+this.operands.length:"")};var n=b.extend({constructor:function(a){var c=a.getFormulaResource().getOperatorCollection(),e=a.getFormulaResource().getFunctionCollection();b.call(this,a),this.compileTokens=d.profileMethod("FormulaCompiler.compileTokens()",function(a){function b(){return a[F]||null}function m(){var a=b();return a&&(F+=1),a}function n(){for(var a=m();a&&a.isType("ws");)a=m();return a}function o(){var a=n();if(a)return a;throw new i("unexpected end of formula","missing")}function p(a,b){if(H.length<b)throw new i("invalid operand stack size","missing");var d=b>0?H.splice(-b):[],f=a.isType("op")?c.get(a.getValue()):a.isType("func")?e.get(a.getValue()):null;H.push(new g(a,d,f)),f&&!f.resolve&&a.isType("func")&&(J[f.key]=!0)}function q(a){H.push(new g(a))}function r(a,b,c){var d=a(n());return p(b,c),d}function s(a,b){var c=G;return G=b,a=t(a),G=c,a}function t(a){for(a=u(a);f(a,"cmp");)a=r(u,a,2);return a}function u(a){for(a=v(a);f(a,"con");)a=r(v,a,2);return a}function v(a){for(a=w(a);f(a,"add");)a=r(w,a,2);return a}function w(a){for(a=x(a);f(a,"mul");)a=r(x,a,2);return a}function x(a){for(a=y(a);f(a,"pow");)a=r(y,a,2);return a}function y(a){for(a=f(a,"add")?r(y,a,1):z(a);f(a,"pct");)p(a,1),a=n();return a}function z(a){for(a=A(a);a&&(f(a,"list")||!G&&a.isType("sep"));)a.isType("sep")&&(a=new k("list")),a=r(A,a,2);return a}function A(a){for(a=B(a);f(a,"isect");)a=r(B,a,2);return a}function B(a){for(a=C(a);f(a,"range");)a=r(C,a,2);return a}function C(a){if(!a)throw new i("unexpected end of formula","missing");if(a instanceof l&&a.hasSheetError())throw new i("invalid sheet name","unexpected");switch(a.getType()){case"lit":case"mat":case"ref":case"name":case"table":return q(a),n();case"open":return D();case"func":case"macro":return E(a)}throw new i("operand expected","unexpected")}function D(){var a=s(o());if(a){if(!a.isType("close"))throw new i("closing parenthesis expected","unexpected")}else I+=1;return n()}function E(a){for(var b=a,c="start",d=0;"end"!==c;)switch(c){case"start":if(a=o(),!a.isType("open"))throw new i("opening parenthesis expected","unexpected");c="open";break;case"open":a=n(),a||(I+=1),c=!a||a.isType("close")?"close":"param";break;case"param":if(d+=1,a||(I+=1),!a||a.matchesType(/^(sep|close)$/))q(new j(null));else if(a=s(a,!0)){if(!a.matchesType(/^(sep|close)$/))throw new i("parameter separator expected","unexpected")}else I+=1;c=a?a.getType():"close";break;case"sep":a=n(),c="param";break;case"close":p(b,d),c="end"}return n()}var F=0,G=!1,H=[],I=0,J={};try{d.logTokens("compiling",a);var K=s(o());if(0===H.length)throw new i("missing formula expression","missing");if(H.length>1)throw new i("invalid formula expression","unexpected");if(K||F<a.length)throw new i("unexpected garbage at end of formula","unexpected");d.withLogging(function(){var a=[];!function b(c){a.push(c),c.isOperator()&&c.operands.forEach(b)}(H[0]),d.logTokens("compiled",a)})}catch(L){if(L instanceof i)return d.warn("error: "+L.message+", index="+(F-1)),{root:new g(new j(h.NA)),error:L.type,missingClose:0,missingFuncs:null};throw L}return{root:H[0],error:null,missingClose:I,missingFuncs:J}}),this.registerDestructor(function(){a=c=e=null})}});return n});