define("io.ox/office/spreadsheet/model/formula/interpret/formulacontext",["io.ox/office/tk/utils","io.ox/office/tk/utils/iteratorutils","io.ox/office/spreadsheet/utils/config","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/interpret/operand","io.ox/office/spreadsheet/model/formula/interpret/filteraggregator"],function(a,b,c,d,e,f,g){"use strict";function h(a){return a.forEach(e.throwErrorCode),a}function i(a,b){return a.forEach(function(a){if(e.throwErrorCode(a),!b(a))throw s.VALUE}),a}function j(a){if(a.empty())throw s.NULL;if(!a.singleSheet())throw s.VALUE;return a}function k(a){return a instanceof f?a.getType():a instanceof A?"mat":a instanceof v||a instanceof w?"ref":"val"}function l(a){var b=a instanceof f?a.getRawValue():a;return b instanceof A?b.size():b instanceof v||b instanceof w?b.cells():1}function m(b,c){return a.getStringOption(c,k(b)+"Mode","convert")}function n(a){var c=0;return b.createTransformIterator(a,function(a,b){return null===a?null:(b.index=c,c+=1,b)})}function o(a){return null!==a}function p(a){return null===a}function q(a){return""===a||null===a}function r(b,c){this._formulaInterpreter=b.getFormulaInterpreter(),this._dependencyManager=b.getDependencyManager(),this._refSheet=a.getIntegerOption(c,"refSheet",null),this._refAddress=a.getOption(c,"targetAddress",t.A1).clone(),this._targetAddress=this._refAddress.clone(),this._detectCircular=a.getBooleanOption(c,"detectCircular",!1),this._recalcDirty=a.getOption(c,"recalcDirty",!1),this._standardFormat=b.getNumberFormatter().getStandardFormat(),this._MAX_STRING_LEN="odf"===b.getApp().getFileFormat()?65535:32767,this._END_EVAL_TIME=_.now()+e.MAX_EVAL_TIME,this._resolverStack=[],this._operandResolver=null,this._contextType="any",this._matDim=null,this._matRow=0,this._matCol=0,this.app=b.getApp(),this.docModel=b,this.fileFormat=this.app.getFileFormat(),this.formulaResource=b.getFormulaResource(),this.formulaGrammar=b.getFormulaGrammar("ui"),this.numberFormatter=b.getNumberFormatter()}var s=d.ErrorCode,t=d.Address,u=d.Range,v=d.Range3D,w=d.Range3DArray,x=e.Math,y=e.Scalar,z=e.Complex,A=e.Matrix,B=e.Dimension,C=x.isZero,D=c.getDebugUrlFlag("spreadsheet:debug-formulas"),E=_.constant(!1);return r.prototype._getScalar=function(a){return"mat"===this._contextType?a.getScalar(this._matRow,this._matCol):a.getScalar(null,null)},r.prototype._getCellValue=function(a,b){if(!this._recalcDirty)return a.getCellCollection().getValue(b);var c=this._dependencyManager.getCellValue(a,b);return this._END_EVAL_TIME+=c.time,c.value},r.prototype._checkCircularReference=function(a){if(this._detectCircular&&_.isNumber(this._refSheet)&&a.containsSheet(this._refSheet)&&a.containsAddress(this._refAddress))throw e.CIRCULAR_ERROR;return a},r.prototype._createOperandIterator=function(c,d,g){function h(a,b,c,f,g,h){return q||e.throwErrorCode(a),(u+=1)%50===0&&n.checkEvalTime(),a=d.call(n,a),!h&&r&&(h=n._standardFormat),{value:a,format:h,offset:b+c*g+f,col:f,row:g}}function i(a){return o||null!==a?b.createSingleIterator(h(a,0,1,0,0,null)):b.ALWAYS_DONE_ITERATOR}function j(a){var c=a.cols();return b.createTransformIterator(a.iterator(),function(a,b){return h(a,0,c,b.col,b.row,null)})}function k(a,c,d){var e=c.start[0],f=c.start[1],g=c.cols(),i=a.getCellCollection(),j=s||t&&a.getTableCollection().hasFilteredTables()?"rows":!1,k=i.createAddressIterator(c,{type:p?"all":"value",covered:!0,visible:j});return b.createTransformIterator(k,function(b){var c=r?i.getParsedFormat(b):null;return h(n._getCellValue(a,b),d,g,b[0]-e,b[1]-f,c)})}function l(a,c){var d=a.toRange(),e=d.cells(),f=n.docModel.createSheetIntervalIterator(a.sheet1,a.sheet2,{types:"worksheet"});return b.createNestedIterator(f,function(a){var b=c;return c+=e,k(a,d,b)})}function m(c){if(a.getBooleanOption(g,"complexRef",!1)){var d=w.iterator(c),e=0;return b.createNestedIterator(d,function(a){n._checkCircularReference(a);var b=e;return e+=a.cells(),l(a,b)})}return l(n.convertToValueRange(c),0)}var n=this,o=a.getBooleanOption(g,"emptyParam",!1),p=a.getBooleanOption(g,"emptyCells",!1),q=a.getBooleanOption(g,"acceptErrors",!1),r=a.getOption(g,"collectFormats",!1),s=a.getBooleanOption(g,"skipHiddenRows",!1),t=a.getBooleanOption(g,"skipFilteredRows",!1),u=0;if(c instanceof f){var x=c.getRawValue();switch(c.getType()){case"val":return i(x);case"mat":return j(x);case"ref":return m(x)}e.throwInternal("FormulaContext._createOperandIterator(): invalid operand type")}return c instanceof A?j(c):c instanceof v||c instanceof w?m(c):_.isUndefined(c)?b.ALWAYS_DONE_ITERATOR:i(c)},r.prototype._iterateValues=function(a,c){var d=0;return b.forEach(a,function(a,b){c.call(this,a,d,b.offset,b.col,b.row,b.format),d+=1},this),d},r.prototype._aggregateValues=function(b,c,d,f,g,h){var i=c,j=0,k=0,m=a.getBooleanOption(h,"collectFormats",!0),n=m?this._standardFormat:null;return _.each(b,function(a){j+=d.call(this,a,function(a,b,c,d,g,h){var l=j+b,m=k+c;i=f.call(this,i,a,l,m),n&&(n=e.combineParsedFormats(n,h))},h),k+=l(a)},this),i=e.throwErrorCode(g.call(this,i,j,k)),n?this.createOperand(i,{format:n}):i},r.prototype.setMatrixPosition=function(a,b){return this._targetAddress[0]+=b-this._matCol,this._targetAddress[1]+=a-this._matRow,this._matRow=a,this._matCol=b,this},r.prototype.pushOperandResolver=function(a,b,c){return this._resolverStack.push({resolver:this._operandResolver,contextType:this._contextType,matDim:this._matDim,matRow:this._matRow,matCol:this._matCol}),this._operandResolver=a,this._contextType=b,this._matDim=c,this.setMatrixPosition(null,null)},r.prototype.popOperandResolver=function(){var a=this._resolverStack.pop();return this._operandResolver=a.resolver,this._contextType=a.contextType,this._matDim=a.matDim,this.setMatrixPosition(a.matRow,a.matCol)},r.prototype.getContextType=function(){return this._contextType},r.prototype.convertToNumber=function(a,b){if(e.throwErrorCode(a),a=this.numberFormatter.convertScalarToNumber(a,b),null===a)throw s.VALUE;return a},r.prototype.convertToDate=function(a,b){if(e.throwErrorCode(a),a=this.numberFormatter.convertScalarToDate(a,b),null===a)throw s.VALUE;return a},r.prototype.convertToString=function(a){if(e.throwErrorCode(a),a=this.numberFormatter.convertScalarToString(a,d.MAX_LENGTH_STANDARD_FORMULA),null===a)throw s.VALUE;return a},r.prototype.convertToBoolean=function(a){if(e.throwErrorCode(a),a=this.numberFormatter.convertScalarToBoolean(a),null===a)throw s.VALUE;return a},r.prototype.convertToComplex=function(a){if(e.throwErrorCode(a),_.isBoolean(a))throw s.VALUE;if(a instanceof Date&&(a=this.convertToNumber(a)),_.isNumber(a)&&_.isFinite(a)?a=new z(a,0):_.isString(a)?a=this.numberFormatter.convertStringToComplex(a):null===a&&(a=new z(0,0)),a instanceof z)return a;throw s.NUM},r.prototype.convertToRange=function(b,c){if(b=w.get(b),b.empty())throw s.NULL;if(b.length>1)throw a.getOption(c,"errorCode",s.REF);if(!a.getBooleanOption(c,"multiSheet",!1)&&!b[0].singleSheet())throw s.VALUE;return b[0]},r.prototype.convertToValueRange=function(a){return this._checkCircularReference(this.convertToRange(a,{errorCode:s.VALUE}))},r.prototype.convertOperandToValue=function(a,b){switch(b){case"any":case"any:lazy":return a;case"val":return e.throwErrorCode(this._getScalar(a));case"val:num":return this.convertToNumber(this._getScalar(a));case"val:int":return this.convertToNumber(this._getScalar(a),!0);case"val:date":return this.convertToDate(this._getScalar(a));case"val:day":return this.convertToDate(this._getScalar(a),!0);case"val:str":return this.convertToString(this._getScalar(a));case"val:bool":return this.convertToBoolean(this._getScalar(a));case"val:comp":return this.convertToComplex(this._getScalar(a));case"val:any":return this._getScalar(a);case"mat":return h(a.getMatrix());case"mat:num":return i(a.getMatrix(),_.isNumber);case"mat:str":return i(a.getMatrix(),_.isString);case"mat:bool":return i(a.getMatrix(),_.isBoolean);case"mat:any":return a.getMatrix();case"ref":return a.getRanges();case"ref:sheet":return j(a.getRanges());case"ref:single":return this.convertToRange(a.getRanges());case"ref:multi":return this.convertToRange(a.getRanges(),{multiSheet:!0});case"ref:val":return this.convertToValueRange(a.getRanges())}e.throwInternal('FormulaContext.convertOperandToValue(): unknown type specifier: "'+b+'"')},r.prototype.equalScalars=function(a,b){return this._formulaInterpreter.equalScalars(a,b)},r.prototype.compareScalars=function(a,b){return this._formulaInterpreter.compareScalars(a,b)},r.prototype.validateValue=function(a){if(a instanceof Date)return a=this.numberFormatter.convertDateToNumber(a),_.isNumber(a)?a:s.NUM;if(a instanceof z){if(!_.isFinite(a.real)||!_.isFinite(a.imag))return s.NUM;C(a.real)&&(a.real=0),C(a.imag)&&(a.imag=0),a=this.numberFormatter.convertComplexToString(a,d.MAX_LENGTH_STANDARD_FORMULA)}return _.isNumber(a)?_.isFinite(a)?C(a)?0:a:s.NUM:_.isString(a)?a.length<=this._MAX_STRING_LEN?a:s.VALUE:a},r.prototype.checkStringLength=function(a){if(0>a||a>this._MAX_STRING_LEN)throw s.VALUE},r.prototype.checkStringIndex=function(a){if(1>a||a>this._MAX_STRING_LEN)throw s.VALUE},r.prototype.concatStrings=function(){var a=_.reduce(arguments,function(a,b){return a+b},"");return this.checkStringLength(a.length),a},r.prototype.repeatString=function(b,c){return this.checkStringLength(b.length*c),0===b.length?"":a.repeatString(b,c)},r.prototype.checkCellRef=function(a){if(!this.docModel.isValidAddress(a.toAddress()))throw s.VALUE},r.prototype.checkRangeDims=function(a,b){if(!u.prototype.equalSize.call(a,b))throw s.VALUE},r.prototype.checkEvalTime=D?_.noop:function(){if(_.now()>this._END_EVAL_TIME)throw e.TIMEOUT_ERROR},r.prototype.getOperandCount=function(){return this._operandResolver.size()},r.prototype.getOperand=function(a,b){var c=this._operandResolver.resolve(a);if(!c)throw s.NA;return b?this.convertOperandToValue(c,b):c},r.prototype.getOperandValue=function(a){return this.getOperand(a).getRawValue()},r.prototype.isMissingOperand=function(a){return a>=this._operandResolver.size()},r.prototype.isEmptyOperand=function(a){var b=this._operandResolver.resolve(a);return!!b&&b.isEmpty()},r.prototype.isMissingOrEmptyOperand=function(a){return this.isMissingOperand(a)||this.isEmptyOperand(a)},r.prototype.getOperands=function(a,b){var c=this._operandResolver,d=c.size()-a;if(b&&(d=Math.min(d,b)),1>d)throw s.VALUE;return _.times(d,function(b){return c.resolve(a+b)})},r.prototype.iterateOperands=function(a,b){return this.getOperands(a).forEach(function(c,d){b.call(this,c,a+d)},this),this},r.prototype.createOperand=function(a,b){return new f(this,a,b)},r.prototype.isRefSheet=function(a){var b=this._refSheet;return null!==b&&b>=0&&b===a},r.prototype.getRefSheet=function(){if("number"!=typeof this._refSheet)throw s.REF;return this._refSheet},r.prototype.getRefSheetModel=function(){return this.docModel.getSheetModel(this.getRefSheet())},r.prototype.getRefAddress=function(){return this._refAddress.clone()},r.prototype.isTargetAddress=function(a){return this._targetAddress.equals(a)},r.prototype.getTargetAddress=function(){return this._targetAddress.clone()},r.prototype.getMatrixAddress=function(a){return A.getAddress(a,this._matRow,this._matCol)},r.prototype.getCellValue=function(a,b){var c=this.docModel.getSheetModel(a);if(!c)throw s.REF;return this._getCellValue(c,b)},r.prototype.getCellMatrix=function(a,c){var d=this.docModel.getSheetModel(a);if(!d)throw s.REF;var f=B.createFromRange(c);e.ensureMatrixDim(f);var g=A.create(f.rows,f.cols,null),h=d.getCellCollection().createAddressIterator(c,{type:"value",covered:!0});return b.forEach(h,function(a){g.set(a[1]-c.start[1],a[0]-c.start[0],this._getCellValue(d,a))},this),g},r.prototype.getCellFormula=function(a,b){var c=this.docModel.getSheetModel(a);if(!c)throw s.REF;var d=c.getCellCollection().getTokenArray(b,{fullMatrix:!0,grammarId:"ui"});return d?{formula:d.formula,matrix:!!d.matrixRange}:null},r.prototype.createParallelIteratorSome=function(a){function c(a,b){return b.offset}return b.createParallelIterator(a,c)},r.prototype.createParallelIteratorEvery=function(a){var c=this.createParallelIteratorSome(a);return b.createTransformIterator(c,function(a,b){if(b.complete){var c=b.results[0];return{value:a,offset:b.offset,col:c.col,row:c.row,results:b.results}}})},r.prototype.createScalarIterator=function(a,b){return this._createOperandIterator(a,_.identity,b)},r.prototype.iterateScalars=function(a,b,c){var d=this.createScalarIterator(a,c);return this._iterateValues(d,b)},r.prototype.getScalarsAsArray=function(a,c){return b.toArray(this.createScalarIterator(a,c))},r.prototype.createNumberIterator=function(b,c){var d=m(b,c),f=a.getBooleanOption(c,"skipErrors",!1),g=a.getBooleanOption(c,"floor",!1),h=a.getBooleanOption(c,"dates",!1),i=this._createOperandIterator(b,function(a){if(f&&a instanceof s)return null;switch(d){case"convert":a=this.convertToNumber(a,g);break;case"rconvert":if(_.isBoolean(a))throw s.VALUE;a=this.convertToNumber(a,g);break;case"exact":if(_.isString(a)||_.isBoolean(a)||null===a)throw s.VALUE;a=this.convertToNumber(a,g);break;case"skip":_.isNumber(a)?g&&(a=Math.floor(a)):a=null;break;case"zero":a=_.isString(a)?0:this.convertToNumber(a,g);break;default:e.throwInternal('FormulaContext.createNumberIterator(): unknown conversion mode: "'+d+'"')}return h&&_.isNumber(a)?this.convertToDate(a):a},_.extend({},c,{emptyCells:!1,acceptErrors:f}));return n(i)},r.prototype.iterateNumbers=function(a,b,c){var d=this.createNumberIterator(a,c);return this._iterateValues(d,b)},r.prototype.getNumbersAsArray=function(a,c){return b.toArray(this.createNumberIterator(a,c))},r.prototype.aggregateNumbers=function(a,b,c,d,e){return this._aggregateValues(a,b,this.iterateNumbers,c,d,e)},r.prototype.aggregateNumbersAsArray=function(a,b,c){function d(a,b){return f.push(b),a+b}function e(a,c){return b.call(this,f,a,c)}var f=[];return this.aggregateNumbers(a,0,d,e,c)},r.prototype.aggregateNumbersParallel=function(c,d,g,h,i){c=_.map(c,function(a){return a instanceof f?a:this.createOperand(a)},this);var j=a.getStringOption(i,"checkSize","exact");if(c.length>1&&"none"!==j){var k="size"!==j,l=c[0].getDimension({errorCode:s.VALUE}),m=l.size();c.forEach(function(b,c){if(0!==c){var d=b.getDimension({errorCode:s.VALUE});if(k?!l.equals(d):m!==d.size())throw a.getOption(i,"sizeMismatchError",s.VALUE)}})}var n=c.map(function(a){return this.createNumberIterator(a,i)},this),o=d,p=0,q=this.createParallelIteratorEvery(n);return b.forEach(q,function(a){o=g.call(this,o,a,p),p+=1}),e.throwErrorCode(h.call(this,o,p))},r.prototype.aggregateNumbersParallelAsArrays=function(a,b,c){function d(a,b){return f.push(b),b.forEach(function(b,c){a[c]+=b}),a}function e(a,c){return b.call(this,f,a,c)}var f=[],g=_.times(a.length,_.constant(0));return this.aggregateNumbersParallel(a,g,d,e,c)},r.prototype.createStringIterator=function(a,b){var c=m(a,b),d=this._createOperandIterator(a,function(a){switch(c){case"convert":return this.convertToString(a);case"skip":return"string"==typeof a?a:null;default:e.throwInternal('FormulaContext.createStringIterator(): unknown conversion mode: "'+c+'"')}},_.extend({},b,{emptyCells:!1,acceptErrors:!1}));return n(d)},r.prototype.iterateStrings=function(a,b,c){var d=this.createStringIterator(a,c);return this._iterateValues(d,b)},r.prototype.aggregateStrings=function(a,b,c,d,e){return this._aggregateValues(a,b,this.iterateStrings,c,d,e)},r.prototype.createBooleanIterator=function(a,b){var c=m(a,b),d=this._createOperandIterator(a,function(a){switch(c){case"convert":return this.convertToBoolean(a);case"skip":return _.isString(a)?null:this.convertToBoolean(a);default:e.throwInternal('FormulaContext.createBooleanIterator(): unknown conversion mode: "'+c+'"')}},_.extend({},b,{emptyCells:!1,acceptErrors:!1}));return n(d)},r.prototype.iterateBooleans=function(a,b,c){var d=this.createBooleanIterator(a,c);return this._iterateValues(d,b)},r.prototype.aggregateBooleans=function(a,b,c,d,e){return this._aggregateValues(a,b,this.iterateBooleans,c,d,e)},r.prototype.isMatrixMode=function(){return"mat"===this._contextType&&!!this._matDim},r.prototype.getMatrixDim=function(){return this._matDim},r.prototype.aggregateMatrix=function(a,b){try{return this.pushOperandResolver(this._operandResolver,"mat",a),A.generate(a.rows,a.cols,function(a,c){this.checkEvalTime(),this.setMatrixPosition(a,c);try{return b.call(this,a,c)}catch(d){if(d instanceof s)return d;throw d}},this)}finally{this.popOperandResolver()}},r.prototype.countBlankCells=function(b,c){var d=a.getBooleanOption(c,"emptyStr",!1),e=0,f=d?function(a){""!==a&&(e+=1)}:function(){e+=1};return this.iterateScalars(b,f,{acceptErrors:!0,complexRef:!0}),b.cells()-e},r.prototype.convertPatternToRegExp=function(a,b){return a=_.escapeRegExp(a).replace(/(^|[^~])\\\*/g,"$1.*").replace(/(^|[^~])\\\?/g,"$1.").replace(/~(\\[*?])/g,"$1"),b&&(a="^"+a+"$"),new RegExp(a,"i")},r.prototype.createFilterMatcher=function(a){var b=this.numberFormatter,c=null,d=null,f=null;if("string"==typeof a){var g=/^(<=|>=|<>|<|>|=)?(.*)$/.exec(a);c=g[1]||"",d=b.parseValue(g[2],{keepApos:!0})}else c="",d=a;if(f=""===c||"="===c,null===d)return function(a){return 0===("string"==typeof a?b.parseValue(a):a)};if(""===d)switch(c){case"":return q;case"=":return p;case"<>":return o;default:return E}var h=y.getType(d);if(h===y.Type.STRING&&/[*?]/.test(d)&&(f||"<>"===c)){var i=this.convertPatternToRegExp(d,!0);return function(a){return f===("string"==typeof a&&i.test(a))}}h===y.Type.STRING&&(d=d.toUpperCase());var j=f&&h===y.Type.NUMBER;return function(a){if(j&&"string"==typeof a){var f=b.parseValue(a);"number"==typeof f&&(a=f)}var g=null!==a&&h===y.getType(a),i=g?y.compare(a,d):Number.NaN;switch(c){case"":case"=":return isFinite(i)&&0===i;case"<>":return!isFinite(i)||0!==i;case"<":return isFinite(i)&&0>i;case"<=":return isFinite(i)&&0>=i;case">":return isFinite(i)&&i>0;case">=":return isFinite(i)&&i>=0}e.throwInternal("FormulaContext.comparisonMatcher(): invalid operator")}},r.prototype.countFilteredCells=function(){var a=new g(this,0);return a.countMatches()},r.prototype.aggregateFilteredCells=function(a,b,c,d){var e="multi"===a,f=new g(this,e?1:0),h=f.getFilterRange(0),i=e?this.getOperand(0,"ref:val"):this.isMissingOperand(2)?null:this.getOperand(2,"ref:val");return e||(i?(i.end[0]=Math.min(i.start[0]+h.cols()-1,this.docModel.getMaxCol()),i.end[1]=Math.min(i.start[1]+h.rows()-1,this.docModel.getMaxRow()),h.end[0]=h.start[0]+i.cols()-1,h.end[1]=h.start[1]+i.rows()-1):i=h.clone()),f.aggregateNumbers(i,b,c,d)},r});