define("io.ox/office/spreadsheet/model/formula/interpret/formulainterpreter",["io.ox/office/tk/utils","io.ox/office/tk/object/baseobject","io.ox/office/baseframework/model/modelobject","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/presetformattable","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/interpret/operand","io.ox/office/spreadsheet/model/formula/interpret/formulacontext"],function(a,b,c,d,e,f,g,h){"use strict";function i(){this._operands=[]}var j=d.ErrorCode,k=d.Address,l=d.Range,m=d.Range3DArray,n=f.Scalar,o=f.Matrix,p=f.Dimension,q=f.FormulaError;i.prototype.push=function(a){this._operands.push({operand:null,resolve:_.once(a)})},i.prototype.size=function(){return this._operands.length},i.prototype.get=function(a){var b=this._operands[a];return b&&b.operand||null},i.prototype.resolve=function(a){var b=this._operands[a];return b?b.operand=b.resolve():null};var r=b.extend({constructor:function(c,d,n){function r(a){var b=a.getRange3D(n);return b?new m(b):j.REF}function s(a,b,c){var d=a.resolveNameModel(D);if(!d)return j.NAME;var e={refSheet:D,refAddress:k.A1,targetAddress:G.getRefAddress(),recalcDirty:F};return c&&(e.matrixRange=l.createFromAddressAndSize(e.targetAddress,c.cols,c.rows)),d.getTokenArray().interpretFormula(b,e).value}function t(a){var b=a.getRange3D(E);return b?new m(b):j.REF}function u(a,b){if("ref"===b&&"ref"!==a&&"any"!==a)throw new q("expected reference token","reference")}function v(a,b){return!b&&a instanceof g?a:G.createOperand(a,b)}function w(a,b,c){var d=a.token,e=null,g=null;switch(f.log("> resolving operand token "+d+" with context type "+b),d.getType()){case"lit":g=d.getValue(),e=g===j.REF?"ref":"val";break;case"mat":g=d.getMatrix(),e="mat";break;case"ref":g=r(d),e="ref";break;case"name":g=s(d,b,c),e="any";break;case"table":g=t(d),e="ref";break;default:f.throwInternal('InterpreterInstance.makeTokenOperand(): unknown token type: "'+d.getType()+'"')}return u(e,b),v(g)}function x(a,b){if("combine"===b){for(var c=C,d=0;c&&d<a.size();d+=1){var g=a.get(d),h=g&&g.getFormat()||C;c=f.combineParsedFormats(c,h)}return c}var i=null;switch(b){case"percent":i=e.getPercentId(!0);break;case"currency":i=B.getCurrencyCode({red:!0});break;case"fraction":i=e.getFractionId(!0);break;case"date":i=e.SYSTEM_DATE_ID;break;case"time":i=e.getTimeId(null,!0);break;case"datetime":i=e.SYSTEM_DATETIME_ID}return null===i?null:B.getParsedFormat(i)}function y(a,b,c,d,e){G.checkEvalTime();var g=function(){try{G.setMatrixPosition(d,e);var g=c.map(function(a,c){return a?G.convertOperandToValue(a,b[c].typeSpec):null});return f.logTokens("  resolving with parameters",g),a.resolve.apply(G,g)}catch(h){if(h instanceof j)return h;throw h}}();return v(g)}function z(a,b,c){if(a.error)throw a.error;var d=a.token;f.log("> processing operator "+d+" with "+a.operands.length+" parameters and context type "+b);var e=a.descriptor;if(!e)return v(j.NAME);if(u(e.type,b),!_.isFunction(e.resolve))return f.warn('InterpreterInstance.resolveOperatorNode(): unsupported operator or function "'+d+'"'),v(f.UNSUPPORTED_ERROR);if(c&&!o.isValidDim(c))return v(f.UNSUPPORTED_ERROR);var g=new i,h=a.signature;h.forEach(function(d,f){var h=a.operands[f],i="val"===d.baseType&&"val"===e.type,j="force"===d.matSpec?"mat":d.baseType;"mat"!==b||!i&&"pass"!==d.matSpec||(j="mat");var k=i&&"mat"===j;g.push(A.bind(null,h,j,k?c:null))});var k=h.map(function(a,b){return"any:lazy"===a.typeSpec?null:g.resolve(b)});if(!c&&"val"===e.type){var l="mat"===b;if(l||h.every(function(a){return"val"===a.baseType})){try{k.forEach(function(a,b){if(a&&(l?"val"===h[b].baseType&&!a.isScalar():a.isMatrix())){var d=a.getDimension({errorCode:j.VALUE});c=p.boundary(c,d)}})}catch(m){if(m instanceof j)return v(m);throw m}if(c){if(!o.isValidDim(c))return v(f.UNSUPPORTED_ERROR);b="mat"}}}var n=f.takeTime(e.key,function(){try{G.pushOperandResolver(g,b,c);var a=y(e,h,k,0,0);if("any"===e.type||e.type===a.getType()||"mat"===b&&"val"===e.type&&a.isMatrix()||f.throwInternal("InterpreterInstance.resolveOperatorNode(): "+e.name+": operator result type does not match operator return type"),c&&a.isScalar()){f.info("  expand scalar result to "+c+" matrix");var d=o.generate(c.rows,c.cols,function(b,c){if(0===b&&0===c)return a.getRawValue();var d=y(e,h,k,b,c);return d.isScalar()?d.getRawValue():void f.throwInternal("InterpreterInstance.resolveOperatorNode(): invalid matrix element type")});a=v(d)}return a}finally{G.popOperandResolver()}}),q=e.format&&"mat"!==b?x(g,e.format):null;return q?v(n,{format:q}):n}function A(a,b,c){var d=a.isOperator()?z(a,b,c):w(a,b,c);return f.log("< result of "+a+": "+d),d}var B=c.getNumberFormatter(),C=B.getStandardFormat(),D=a.getIntegerOption(n,"refSheet",null),E=a.getOption(n,"targetAddress",k.A1),F=a.getOption(n,"recalcDirty",!1),G=new h(c,n);b.call(this),this.getResult=function(a,b){var c=function(){try{return A(d,a,b)}catch(c){if(c instanceof j)return v(c);throw c}}();a="any"===a?c.getType():a;var e=function(){try{switch(a){case"val":return c.getScalar(null,null);case"mat":return c.getMatrix();case"ref":return c.getRanges();default:f.throwInternal('InterpreterInstance.getResult(): unknown context type: "'+a+'"')}}catch(b){if(b instanceof j)return b;throw b}}(),g={value:e},h=c.getFormat();h&&!h.isStandard()&&(g.format=h);var i=c.getURL();return null!==i&&(g.url=i),g},this.registerDestructor(function(){c=d=n=B=G=null})}}),s=c.extend({constructor:function(b){function d(a,b,c,d){var e="mat"===a?o.create(1,1,d):d;return f.withLogging(function(){f.info("result: type="+b+" code="+c+" value="+n.toString(e))}),{type:b,code:c,value:e}}var e={withCase:"odf"===b.getApp().getFileFormat(),nullMode:"convert"};c.call(this,b),this.equalScalars=function(a,b){return n.equal(a,b,e)},this.compareScalars=function(a,b){return n.compare(a,b,e)},this.createWarnResult=function(a,b){return d(a,"warn",b.key,"value"in b?b.value:b)},this.createErrorResult=function(a,b){return d(a,"error",b,j.NA)},this.interpretTokens=f.profileMethod("FormulaInterpreter.interpretTokens()",function(c,d,e){f.log("contextType="+c);var g=new r(b,d,e);try{var h="mat"===c?a.getOption(e,"matrixRange",null):null,i=h?p.createFromRange(h):null,k=g.getResult(c,i);return f.isInternalError(k.value)?this.createWarnResult(c,k.value):(k.type="valid",f.withLogging(function(){f.info("result: type=valid value="+n.toString(k.value)+" format="+k.format+" url="+k.url)}),k)}catch(l){if(l instanceof j)return this.createWarnResult(c,l);if(l instanceof q)return f.warn("  error: "+l.message),this.createErrorResult(c,l.type);throw l}finally{g.destroy()}}),this.registerDestructor(function(){b=null})}});return s});