define("io.ox/office/spreadsheet/model/formula/parser/expressionparser",["io.ox/office/tk/utils","io.ox/office/tk/locale/parser","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens"],function(a,b,c,d,e){"use strict";function f(a,b){this.token=a,this.index=-1,this.text=b,this.start=0,this.end=0}var g=c.Address,h=d.Matrix,i=d.SheetRef;f.prototype.toString=function(){return this.token.toString()};var j=_.makeExtendable(function(a,b){this.docModel=a,this.grammar=b,this.RE=b.RE,this.refGrammar=b.refGrammar});j.prototype._initOptions=function(b){this.refAddress=a.getOption(b,"refAddress",g.A1),this.refSheet=a.getIntegerOption(b,"refSheet",-1),this.refSheetModel=this.docModel.getSheetModel(this.refSheet),this.wrapReferences=a.getBooleanOption(b,"wrapReferences",!1),this.autoCorrect=a.getBooleanOption(b,"autoCorrect",!1),this.extendSheet=a.getBooleanOption(b,"extendSheet",!1),this.unqualifiedTables=a.getBooleanOption(b,"unqualifiedTables",!1)},j.prototype._parseNextToken=function(a){var c=this.RE,d=null,f=null;return(d=c.STRING_LIT.exec(a))?this.createLiteralToken(d[0].slice(1,d[0].length-1).replace(/""/g,'"'),d[0]):(d=c.BOOLEAN_LIT.exec(a))?this.createLiteralToken(this.grammar.getBooleanValue(d[0]),d[0]):(d=c.ERROR_LIT.exec(a))?this.createLiteralToken(this.grammar.getErrorCode(d[0]),d[0]):(d=c.FRACTION_LIT.exec(a))?this.createLiteralToken(parseInt(d[1],10)+parseInt(d[2],10)/parseInt(d[3],10),d[0]):(d=c.WHITESPACE.exec(a))?this.createFixedToken("ws",d[0]):(d=c.SEPARATOR.exec(a))?this.createToken(new e.SeparatorToken,d[0]):(d=c.OPERATOR.exec(a))?this.createToken(new e.OperatorToken(this.grammar.getOperatorKey(d[0])),d[0]):(d=c.OPEN.exec(a))?this.createToken(new e.ParenthesisToken(!0),d[0]):(d=c.CLOSE.exec(a))?this.createToken(new e.ParenthesisToken(!1),d[0]):(d=c.MATRIX_OPEN.exec(a))?this._parseMatrixLit(a):(f=this.parseNextRefToken(a))?f:(d=b.parseLeadingNumber(a,{dec:this.grammar.DEC}))?this.createLiteralToken(d.number,d.text):(f=this.parseNextNameToken(a))?f:void 0},j.prototype._parseMatrixLit=function(a){function c(){return j.every(function(a,b){return 0===b||a.length===j[b-1].length})}for(var d=a,f="start",g=this.RE,i=null,j=[],k=null;"end"!==f;){switch(f){case"start":(i=g.MATRIX_OPEN.exec(a))&&(j.push(k=[]),f="open");break;case"open":case"sep":(i=g.WHITESPACE.exec(a))||((i=g.FRACTION_LIT.exec(a))?(k.push(parseInt(i[1],10)+parseInt(i[2],10)/parseInt(i[3],10)),f="lit"):(i=b.parseLeadingNumber(a,{dec:this.grammar.DEC,sign:!0}))?(k.push(i.number),i=[i.text],f="lit"):(i=g.STRING_LIT.exec(a))?(k.push(i[0].slice(1,i[0].length-1).replace(/""/g,'"')),f="lit"):(i=g.BOOLEAN_LIT.exec(a))?(k.push(this.grammar.getBooleanValue(i[0])),f="lit"):(i=g.ERROR_LIT.exec(a))&&(k.push(this.grammar.getErrorCode(i[0])),f="lit"));break;case"lit":0===a.length?(i=this.autoCorrect&&c()?[""]:null,f="end"):(i=g.WHITESPACE.exec(a))||((i=g.MATRIX_ROW_SEPARATOR.exec(a))?(j.push(k=[]),f="sep"):(i=g.MATRIX_COL_SEPARATOR.exec(a))?f="sep":(i=g.MATRIX_CLOSE.exec(a))&&(c()||(i=null),f="end"))}if(!i)return null;a=a.substr(i[0].length)}var l=d.substr(0,d.length-a.length);return this.createToken(new e.MatrixToken(new h(j)),l)},j.prototype.createToken=function(a,b){return new f(a,b)},j.prototype.createFixedToken=function(a,b){return this.createToken(new e.FixedToken(a,b),b)},j.prototype.createLiteralToken=function(a,b){return this.createToken(new e.LiteralToken(a),b)},j.prototype.createReferenceToken=function(a,b,c){return!a&&this.extendSheet&&this.refSheetModel&&(a={r1:new i(this.refSheet,!0),r2:null}),this.createToken(new e.ReferenceToken(this.docModel,b?b.r1:null,b?b.r2:null,a?a.r1:null,a?a.r2:null),c)},j.prototype.createNameToken=function(a,b,c){return!a&&this.extendSheet&&this.refSheetModel&&this.refSheetModel.getNameCollection().hasName(b)&&(a=new i(this.refSheet,!0)),this.createToken(new e.NameToken(this.docModel,b,a),c)},j.prototype.createFunctionToken=function(a,b,c){var d=a?null:this.grammar.getFunctionKey(b);return this.createToken(d?new e.FunctionToken(d):new e.MacroToken(this.docModel,b,a),c)},j.prototype.createSheetRef=function(a,b){return this.refGrammar.createSheetRef(this.docModel,a,b)},j.prototype.createSheetRefs=function(a,b,c){return this.refGrammar.createSheetRefs(this.docModel,a,b,c)},j.prototype.createCellRangeRefs=function(a,b,c){return this.refGrammar.createCellRangeRefs(this.docModel,this.refAddress,this.wrapReferences,a,b,c)},j.prototype.createColRangeRefs=function(a,b,c){return this.refGrammar.createColRangeRefs(this.docModel,this.refAddress,this.wrapReferences,a,b,c)},j.prototype.createRowRangeRefs=function(a,b,c){return this.refGrammar.createRowRangeRefs(this.docModel,this.refAddress,this.wrapReferences,a,b,c)},j.prototype.parseNextRefToken=function(){return a.error("ExpressionParserBase.parseNextRefToken(): missing implementation"),null},j.prototype.parseNextNameToken=function(){return a.error("ExpressionParserBase.parseNextNameToken(): missing implementation"),null},j.prototype.parseFormula=function(b,c){this._initOptions(c);for(var f=[];b.length>0;){var g=this._parseNextToken(b)||this.createFixedToken("bad",b);f.push(g),b=b.substr(g.text.length)}d.logTokens("tokenize",f);var h=" "===this.grammar.getOperatorName("isect");return a.iterateArray(f,function(a,b){var c=a.token,d=f[b-1],g=f[b+1];if(c.isType("op")&&"sub"===c.getValue()&&g&&g.token.isType("lit")){var i=g.token.getValue();if("number"==typeof i&&i>0){var j=d&&d.token.isType("ws")?f[b-2]:d;(!j||j.token.matchesType(/^(op|sep|open)$/))&&(a.token=new e.LiteralToken(-i),a.text+=g.text,f.splice(b+1,1))}}if(h&&c.isType("ws")){var k=k=a.text.indexOf(" ");if(k>=0&&d&&d.token.matchesType(/^(ref|name|close)$/)&&g&&g.token.matchesType(/^(ref|name|open|func)$/)){if(k+1<a.text.length){var l=a.text.slice(k+1);f.splice(b+1,0,this.createFixedToken("ws",l))}f.splice(b+1,0,this.createToken(new e.OperatorToken("isect")," ")),k>0?(c.setValue(a.text.slice(0,k)),a.text=c.getValue()):f.splice(b,1)}}},{reverse:!0,context:this}),d.logTokens("postprocess",f),f.forEach(function(a,b){a.index=b,a.start=0===b?0:f[b-1].end,a.end=a.start+a.text.length}),f},j.prototype.destroy=function(){this.docModel=this.grammar=this.RE=this.refSheetModel=null};var k=j.extend({constructor:function(a,b){j.call(this,a,b)}});k.prototype._parseTableRef=function(a,b){function c(){r[m.getTableRegionKey(p[1])]=!0,o="ref"}function d(a,b){"col1Name"in q?(p=null,o="end"):(q.col1Name=m.decodeTableColumn(a),q.col2Name=b?m.decodeTableColumn(b):null,o="ref")}function f(){d(p[1],p[2])}function g(a){a&&p[1]&&(q.openWs=!0),d(p[2]||p[3],p[4]||p[5])}function h(){p[1]&&(q.closeWs=!0),n||0!==p[2].length||(p=null),o="end"}var i=this.RE,j=a;b&&(a=a.substr(b.text.length));var k=i.TABLE_OPEN.test(a),l=b?b.token.resolveTableModel():null;if(b&&k&&!l)return null;if(b&&!k&&l)return this.createToken(new e.TableToken(this.docModel,b.token.getValue()),b.text);if(!k)return b;if(!b&&this.grammar.UI&&this.unqualifiedTables&&this.refSheetModel&&(l=this.refSheetModel.getTableCollection().findTable(this.refAddress)),!l)return null;for(var m=this.grammar,n=this.autoCorrect,o="start",p=null,q={},r={};"end"!==o;){switch(o){case"start":(p=i.TABLE_OPEN.exec(a))&&(p[1]&&(q.openWs=!0),o="open");break;case"open":(p=i.TABLE_CLOSE.exec(a))?h():(p=i.TABLE_SINGLE_REGION_NAME.exec(a))?c():(p=i.TABLE_SINGLE_COLUMN_NAME.exec(a))?f():(p=i.TABLE_REGION_REF.exec(a))?c():!this.grammar.UI&&(p=i.TABLE_COLUMN_RANGE_REF.exec(a))?f():!this.grammar.UI&&(p=i.TABLE_COLUMN_REF.exec(a))?f():this.grammar.UI&&(p=i.TABLE_MIXED_COLUMN_RANGE_REF.exec(a))?g(!0):this.grammar.UI&&(p=i.TABLE_MIXED_COLUMN_REF.exec(a))?g(!0):this.grammar.UI&&(p=i.TABLE_THISROW_REF.exec(a))&&(r.ROW=!0,o="row");break;case"ref":(p=i.TABLE_CLOSE.exec(a))?h():(p=i.TABLE_SEPARATOR.exec(a))&&(p[2]&&(q.sepWs=!0),o="sep");break;case"sep":(p=i.TABLE_REGION_REF.exec(a))?c():!this.grammar.UI&&(p=i.TABLE_COLUMN_RANGE_REF.exec(a))?f():!this.grammar.UI&&(p=i.TABLE_COLUMN_REF.exec(a))?f():this.grammar.UI&&(p=i.TABLE_MIXED_COLUMN_RANGE_REF.exec(a))?g():this.grammar.UI&&(p=i.TABLE_MIXED_COLUMN_REF.exec(a))&&g();break;case"row":(p=i.TABLE_CLOSE.exec(a))?(h(),q.closeWs&&(p=null)):(p=i.WHITESPACE.exec(a))||((p=i.TABLE_MIXED_COLUMN_RANGE_REF.exec(a))?g():(p=i.TABLE_MIXED_COLUMN_REF.exec(a))&&g())}if(!p)return null;a=a.substr(p[0].length)}switch(r=_.keys(r),r.length){case 0:break;case 1:q.regionKey=r[0];break;case 2:if(r=r.join(","),"HEADERS,DATA"===r||"DATA,HEADERS"===r)q.regionKey="HEADERS,DATA";else{if("DATA,TOTALS"!==r&&"TOTALS,DATA"!==r)return null;q.regionKey="DATA,TOTALS"}break;default:return null}var s=j.substr(0,j.length-a.length);return this.createToken(new e.TableToken(this.docModel,l.getName(),q),s)},k.prototype.parseNextRefToken=function(a){var b=this.refGrammar.RE,c=null,d=null;return(c=b.RANGE_REF.exec(a))&&(d=this.createCellRangeRefs(c,1,5))?this.createReferenceToken(null,d,c[0]):(c=b.RANGE_3D_REF.exec(a))&&(d=this.createCellRangeRefs(c,4,8))?this.createReferenceToken(this.createSheetRefs(c,1),d,c[0]):(c=b.RANGE_CUBE_REF.exec(a))&&(d=this.createCellRangeRefs(c,5,9))?this.createReferenceToken(this.createSheetRefs(c,1,!0),d,c[0]):(c=b.CELL_REF.exec(a))&&(d=this.createCellRangeRefs(c,1))?this.createReferenceToken(null,d,c[0]):(c=b.CELL_3D_REF.exec(a))&&(d=this.createCellRangeRefs(c,4))?this.createReferenceToken(this.createSheetRefs(c,1),d,c[0]):(c=b.CELL_CUBE_REF.exec(a))&&(d=this.createCellRangeRefs(c,5))?this.createReferenceToken(this.createSheetRefs(c,1,!0),d,c[0]):(c=b.COLS_REF.exec(a))&&(d=this.createColRangeRefs(c,1,3))?this.createReferenceToken(null,d,c[0]):(c=b.COLS_3D_REF.exec(a))&&(d=this.createColRangeRefs(c,4,6))?this.createReferenceToken(this.createSheetRefs(c,1),d,c[0]):(c=b.COLS_CUBE_REF.exec(a))&&(d=this.createColRangeRefs(c,5,7))?this.createReferenceToken(this.createSheetRefs(c,1,!0),d,c[0]):(c=b.COL_REF.exec(a))&&(d=this.createColRangeRefs(c,1))?this.createReferenceToken(null,d,c[0]):(c=b.COL_3D_REF.exec(a))&&(d=this.createColRangeRefs(c,4))?this.createReferenceToken(this.createSheetRefs(c,1),d,c[0]):(c=b.COL_CUBE_REF.exec(a))&&(d=this.createColRangeRefs(c,5))?this.createReferenceToken(this.createSheetRefs(c,1,!0),d,c[0]):(c=b.ROWS_REF.exec(a))&&(d=this.createRowRangeRefs(c,1,3))?this.createReferenceToken(null,d,c[0]):(c=b.ROWS_3D_REF.exec(a))&&(d=this.createRowRangeRefs(c,4,6))?this.createReferenceToken(this.createSheetRefs(c,1),d,c[0]):(c=b.ROWS_CUBE_REF.exec(a))&&(d=this.createRowRangeRefs(c,5,7))?this.createReferenceToken(this.createSheetRefs(c,1,!0),d,c[0]):(c=b.ROW_REF.exec(a))&&(d=this.createRowRangeRefs(c,1))?this.createReferenceToken(null,d,c[0]):(c=b.ROW_3D_REF.exec(a))&&(d=this.createRowRangeRefs(c,4))?this.createReferenceToken(this.createSheetRefs(c,1),d,c[0]):(c=b.ROW_CUBE_REF.exec(a))&&(d=this.createRowRangeRefs(c,5))?this.createReferenceToken(this.createSheetRefs(c,1,!0),d,c[0]):(c=b.ERROR_3D_REF.exec(a))?this.createReferenceToken(this.createSheetRefs(c,1),null,c[0]):(c=b.ERROR_CUBE_REF.exec(a))?this.createReferenceToken(this.createSheetRefs(c,1,!0),null,c[0]):void 0},k.prototype.parseNextNameToken=function(a){var b=this.RE,c=this.refGrammar.RE,d=null;return(d=c.FUNCTION_REF.exec(a))?this.createFunctionToken(null,d[1],d[0]):(d=c.FUNCTION_3D_REF.exec(a))?this.createFunctionToken(this.createSheetRef(d,1),d[4],d[0]):(d=c.NAME_3D_REF.exec(a))?this._parseTableRef(a,this.createNameToken(this.createSheetRef(d,1),d[4],d[0])):(d=c.NAME_REF.exec(a))?this._parseTableRef(a,this.createNameToken(null,d[1],d[0])):this.grammar.UI&&(d=b.TABLE_OPEN.exec(a))?this._parseTableRef(a,null):void 0};var l=j.extend({constructor:function(a,b){j.call(this,a,b)}});l.prototype.createSheetRangeData=function(a,b){var c=i.create(this.docModel,a[b+1],a[b+2],null,!!a[b]),d=i.create(this.docModel,a[b+4],a[b+5],null,!!a[b+3]);return{r1:c,r2:d}},l.prototype.parseNextRefToken=function(a){var b=this.refGrammar.RE,c=null,d=null;return(c=b.RANGE_REF.exec(a))&&(d=this.createCellRangeRefs(c,1,5))?this.createReferenceToken(null,d,c[0]):(c=b.RANGE_3D_REF.exec(a))&&(d=this.createCellRangeRefs(c,5,9))?this.createReferenceToken(this.createSheetRefs(c,1),d,c[0]):(c=b.RANGE_CUBE_REF.exec(a))&&(d=this.createCellRangeRefs(c,7,11))?this.createReferenceToken(this.createSheetRangeData(c,1),d,c[0]):(c=b.CELL_REF.exec(a))&&(d=this.createCellRangeRefs(c,1))?this.createReferenceToken(null,d,c[0]):(c=b.CELL_3D_REF.exec(a))&&(d=this.createCellRangeRefs(c,5))?this.createReferenceToken(this.createSheetRefs(c,1),d,c[0]):(c=b.CELL_CUBE_REF.exec(a))&&(d=this.createCellRangeRefs(c,7))?this.createReferenceToken(this.createSheetRangeData(c,1),d,c[0]):(c=b.COLS_REF.exec(a))&&(d=this.createColRangeRefs(c,1,3))?this.createReferenceToken(null,d,c[0]):(c=b.COLS_3D_REF.exec(a))&&(d=this.createColRangeRefs(c,5,7))?this.createReferenceToken(this.createSheetRefs(c,1),d,c[0]):(c=b.COLS_CUBE_REF.exec(a))&&(d=this.createColRangeRefs(c,7,9))?this.createReferenceToken(this.createSheetRangeData(c,1),d,c[0]):(c=b.COL_REF.exec(a))&&(d=this.createColRangeRefs(c,1))?this.createReferenceToken(null,d,c[0]):(c=b.COL_3D_REF.exec(a))&&(d=this.createColRangeRefs(c,5))?this.createReferenceToken(this.createSheetRefs(c,1),d,c[0]):(c=b.COL_CUBE_REF.exec(a))&&(d=this.createColRangeRefs(c,7))?this.createReferenceToken(this.createSheetRangeData(c,1),d,c[0]):(c=b.ROWS_REF.exec(a))&&(d=this.createRowRangeRefs(c,1,3))?this.createReferenceToken(null,d,c[0]):(c=b.ROWS_3D_REF.exec(a))&&(d=this.createRowRangeRefs(c,5,7))?this.createReferenceToken(this.createSheetRefs(c,1),d,c[0]):(c=b.ROWS_CUBE_REF.exec(a))&&(d=this.createRowRangeRefs(c,7,9))?this.createReferenceToken(this.createSheetRangeData(c,1),d,c[0]):(c=b.ROW_REF.exec(a))&&(d=this.createRowRangeRefs(c,1))?this.createReferenceToken(null,d,c[0]):(c=b.ROW_3D_REF.exec(a))&&(d=this.createRowRangeRefs(c,5))?this.createReferenceToken(this.createSheetRefs(c,1),d,c[0]):(c=b.ROW_CUBE_REF.exec(a))&&(d=this.createRowRangeRefs(c,7))?this.createReferenceToken(this.createSheetRangeData(c,1),d,c[0]):(c=b.ERROR_3D_REF.exec(a))?this.createReferenceToken(this.createSheetRefs(c,1),null,c[0]):(c=b.ERROR_CUBE_REF.exec(a))?this.createReferenceToken(this.createSheetRangeData(c,1),null,c[0]):void 0},l.prototype.parseNextNameToken=function(a){var b=this.refGrammar.RE,c=null;return(c=b.FUNCTION_REF.exec(a))?this.createFunctionToken(null,c[1],c[0]):(c=b.NAME_REF.exec(a))?this.createNameToken(null,c[1],c[0]):void 0};var m=j.extend({constructor:function(a,b){j.call(this,a,b)}});m.prototype.parseNextRefToken=function(a){var b=this.refGrammar.RE,c=null;return(c=b.CELL_REF.exec(a))?this.createReferenceToken(null,this.createCellRangeRefs(c,1),c[0]):(c=b.CELL_3D_REF.exec(a))?this.createReferenceToken(this.createSheetRefs(c,1),this.createCellRangeRefs(c,5),c[0]):(c=b.RANGE_REF.exec(a))?this.createReferenceToken(null,this.createCellRangeRefs(c,1,5),c[0]):(c=b.RANGE_3D_REF.exec(a))?this.createReferenceToken(this.createSheetRefs(c,1),this.createCellRangeRefs(c,5,9),c[0]):(c=b.RANGE_CUBE_REF.exec(a))?this.createReferenceToken(this.createSheetRefs(c,1,9),this.createCellRangeRefs(c,5,13),c[0]):void 0},m.prototype.parseNextNameToken=function(a){var b=this.refGrammar.RE,c=null;return(c=b.FUNCTION_REF.exec(a))?this.createFunctionToken(null,c[1],c[0]):(c=b.NAME_REF.exec(a))?this.createNameToken(null,c[1],c[0]):void 0};var n={};return n.create=function(b,c){var d=b.getFormulaGrammar(c);switch(d.REF_SYNTAX){case"ooxml":return new k(b,d);case"odfui":return new l(b,d);case"of":return new m(b,d)}a.error('ExpressionParser.create(): invalid reference syntax: "'+d.REF_SYNTAX+'"')},n});