define("io.ox/office/spreadsheet/model/formula/parser/rangelistparser",["io.ox/office/tk/utils","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils"],function(a,b,c){"use strict";var d=b.Address,e=b.Range,f=b.RangeArray,g=c.SheetRef,h=_.makeExtendable(function(a,b){this.docModel=a,this.MAXCOL=a.getMaxCol(),this.MAXROW=a.getMaxRow(),this.grammar=b,this.refGrammar=b.refGrammar,this.addrConfig=this.refGrammar.addrConfig,this.RE=this.refGrammar.RE});h.prototype._initOptions=function(b){this.refSheet=a.getIntegerOption(b,"refSheet",-1),this.refSheetModel=this.docModel.getSheetModel(this.refSheet),this.extSep=a.getBooleanOption(b,"extSep",!1),this.skipSheets=a.getBooleanOption(b,"skipSheets",!1)},h.prototype._parseSeparator=function(a){var b=this.RE,c=null;return(c=b.RL_SEP_WS.exec(a))?{sep:" ",text:c[0]}:this.extSep&&(c=b.RL_SEP_OTHER.exec(a))?{sep:c[0],text:c[0]}:null},h.prototype.getAddress=function(a,b){return this.addrConfig.getAddress(a,b,this.MAXCOL,this.MAXROW)},h.prototype.getRange=function(a,b,c){var d=this.getAddress(a,b),f="number"==typeof c?this.getAddress(a,c):d;return d&&f?e.createFromAddresses(d,f):null},h.prototype.getColRange=function(a,b,c){var d=this.addrConfig.getCol(a,b,this.MAXCOL),f="number"==typeof c?this.addrConfig.getCol(a,c,this.MAXCOL):d;return d>=0&&f>=0?e.create(d,0,f,this.MAXROW):null},h.prototype.getRowRange=function(a,b,c){var d=this.addrConfig.getRow(a,b,this.MAXROW),f="number"==typeof c?this.addrConfig.getRow(a,c,this.MAXROW):d;return d>=0&&f>=0?e.create(0,d,this.MAXCOL,f):null},h.prototype.createRangeDesc=function(a,b,c){if(!b)return null;if(a){if(a.r1.sheet!==this.refSheet)return null;if(a.r2&&a.r2.sheet!==this.refSheet)return null}return{range:b,text:c}},h.prototype.implParseRange=function(){return a.error("RangeListParserBase.implParseRange(): missing implementation"),null},h.prototype.implFormatRange=function(){return a.error("RangeListParserBase.implFormatRange(): missing implementation"),null},h.prototype.parseRange=function(a,b){this._initOptions(b);var c=this.implParseRange(a);return c&&a.length===c.text.length?c.range:null},h.prototype.formatRange=function(b,c){var d=a.getStringOption(c,"sheetName",null);return this.implFormatRange(b,d)},h.prototype.parseRangeList=function(a,b){this._initOptions(b);for(var c="start",d=new f,e=null;"end"!==c;)switch(c){case"start":c="range";break;case"range":var g=this.implParseRange(a);if(!g)return null;d.push(g.range),a=a.substr(g.text.length),c="sep";break;case"sep":if(0===a.length){c="end";break}var h=this._parseSeparator(a);if(!h||null!==e&&e!==h.sep)return null;e=h.sep,a=a.substr(h.text.length),c="range"}return d},h.prototype.formatRangeList=function(b,c){var d=a.getStringOption(c,"sep"," "),e=a.getStringOption(c,"sheetName",null);return f.get(b).map(function(a){return this.implFormatRange(a,e)},this).join(d)},h.prototype.destroy=function(){this.docModel=this.grammar=this.RE=this.refSheetModel=null};var i=h.extend({constructor:function(a,b){h.call(this,a,b)}});i.prototype.implParseRange=function(a){var b=this.RE,c=null;if(this.skipSheets){if(c=b.RL_RANGE_3D_REF.exec(a))return this.createRangeDesc(null,this.getRange(c,3,5),c[0]);if(c=b.RL_CELL_3D_REF.exec(a))return this.createRangeDesc(null,this.getRange(c,3),c[0]);if(c=b.RL_COLS_3D_REF.exec(a))return this.createRangeDesc(null,this.getColRange(c,3,4),c[0]);if(c=b.RL_COL_3D_REF.exec(a))return this.createRangeDesc(null,this.getColRange(c,3),c[0]);if(c=b.RL_ROWS_3D_REF.exec(a))return this.createRangeDesc(null,this.getRowRange(c,3,4),c[0]);if(c=b.RL_ROW_3D_REF.exec(a))return this.createRangeDesc(null,this.getRowRange(c,3),c[0])}return(c=b.RL_RANGE_REF.exec(a))?this.createRangeDesc(null,this.getRange(c,1,3),c[0]):(c=b.RL_CELL_REF.exec(a))?this.createRangeDesc(null,this.getRange(c,1),c[0]):(c=b.RL_COLS_REF.exec(a))?this.createRangeDesc(null,this.getColRange(c,1,2),c[0]):(c=b.RL_COL_REF.exec(a))?this.createRangeDesc(null,this.getColRange(c,1),c[0]):(c=b.RL_ROWS_REF.exec(a))?this.createRangeDesc(null,this.getRowRange(c,1,2),c[0]):(c=b.RL_ROW_REF.exec(a))?this.createRangeDesc(null,this.getRowRange(c,1),c[0]):void 0},i.prototype.implFormatRange=function(a,b){var c=null,e=null;a.single()?c=a.start.toString():this.docModel.isRowRange(a)?(c=d.stringifyRow(a.start[1]),e=d.stringifyRow(a.end[1])):this.docModel.isColRange(a)?(c=d.stringifyCol(a.start[0]),e=d.stringifyCol(a.end[0])):(c=a.start.toString(),e=a.end.toString());var f=b?new g(b,!1):null;return this.grammar.formatGenericRange(this.docModel,f,null,c,e)};var j=h.extend({constructor:function(a,b){h.call(this,a,b)}});j.prototype.implParseRange=function(a){var b=this.RE,c=null;if(this.skipSheets){if(c=b.RL_RANGE_CUBE_REF.exec(a))return this.createRangeDesc(null,this.getRange(c,3,7),c[0]);if(c=b.RL_RANGE_3D_REF.exec(a))return this.createRangeDesc(null,this.getRange(c,3,5),c[0]);if(c=b.RL_CELL_3D_REF.exec(a))return this.createRangeDesc(null,this.getRange(c,3),c[0])}return(c=b.RL_RANGE_REF.exec(a))?this.createRangeDesc(null,this.getRange(c,1,3),c[0]):(c=b.RL_CELL_REF.exec(a))?this.createRangeDesc(null,this.getRange(c,1),c[0]):void 0},j.prototype.implFormatRange=function(a,b){var c=a.start.toString(),d=a.single()?null:a.end.toString(),e=b?new g(b,!1):null,f=b&&d?e:null;return this.grammar.formatGenericRange(this.docModel,e,f,c,d)};var k={};return k.create=function(b,c){var d=b.getFormulaGrammar(c);switch(d.REF_SYNTAX){case"ooxml":case"odfui":return new i(b,d);case"of":return new j(b,d)}a.error('RangeListParser.create(): invalid reference syntax: "'+d.REF_SYNTAX+'"')},k});