define("io.ox/office/spreadsheet/model/formula/tokenarray",["io.ox/office/tk/utils","io.ox/office/tk/container/simplemap","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens"],function(a,b,c,d,e){"use strict";function f(a,c){this._docModel=a.getDocModel(),this._sheetModel=a===this._docModel?null:a,this._changeHandlers=null,this._allTokens=[],this._sheet3dTokens=[],this._refTokens=[],this._nameTokens=[],this._tokenTypeSet={},this._wrapReferences="name"===c,this._freezeRelRefs="name"===c,this._detectCircular="cell"===c,this._unqualifiedTables="cell"===c,this._compileDesc=null,this._resultCache=null,this._interpreting=new b}var g=c.Address,h=c.RangeArray,i=c.Range3DArray,j=d.CellRef,k=d.SheetRef,l=e.SeparatorToken,m=e.ParenthesisToken,n=e.ReferenceToken,o=e.NameToken;return f.prototype._registerToken=function(a){this._tokenTypeSet[a.getType()]=!0,a.hasSheetRef&&a.hasSheetRef()&&this._sheet3dTokens.push(a),a instanceof n&&this._refTokens.push(a),a instanceof o&&this._nameTokens.push(a)},f.prototype._invokeChangeHandlers=function(a,b){this._compileDesc=null,this.clearResultCache(),this._changeHandlers&&this._changeHandlers.forEach(function(c){c.call(this,a,b)},this)},f.prototype._resolveChangedFormula=function(a,b){var c=this._docModel.getFormulaGrammar(a),d="",e="";return this._allTokens.forEach(function(a){var f=a.getText(c),g=b.call(this,a,c);d+=f,e+=null===g?f:g},this),d===e?null:{old:d,"new":e}},f.prototype._resolveRefSheet=function(b){return this._sheetModel?this._sheetModel.getIndex():a.getIntegerOption(b,"refSheet",null)},f.prototype._extendWithOwnOptions=function(a){return _.extend({wrapReferences:this._wrapReferences},a,{refSheet:this._resolveRefSheet(a),detectCircular:this._detectCircular,unqualifiedTables:this._unqualifiedTables})},f.prototype._compileTokens=function(a){return this._docModel.getFormulaCompiler().compileTokens(a)},f.prototype._isInterpreting=function(a){return this._interpreting.has(a.key())},f.prototype._lockInterpreting=function(a,b){var c=a.key();try{return this._interpreting.insert(c,!0),b.call(this)}finally{this._interpreting.remove(c)}},f.prototype.getSheetModel=function(){return this._sheetModel},f.prototype.empty=function(){return 0===this._allTokens.length},f.prototype.hasToken=function(a){return a in this._tokenTypeSet},f.prototype.hasRefTokens=function(){return this.hasToken("ref")||this.hasToken("name")||this.hasToken("table")},f.prototype.hasSheet3dTokens=function(){return this._sheet3dTokens.length>0},f.prototype.getFormula=function(a,b){var c=this._docModel.getFormulaGrammar(a),d=this._extendWithOwnOptions(b);return this._allTokens.reduce(function(a,b){return a+b.getText(c,d)},"")},f.prototype.resolveStringList=function(){var a=[],b="";return this._allTokens.every(function(c){switch(c.getType()){case"lit":return b+="L",a.push(c.getValue()),_.isString(_.last(a));case"sep":return b+=",",!0;case"ws":return!0;default:return b+="I",!1}}),/^L(,L)*$/.test(b)?a:null},f.prototype.resolveRangeList=function(b){var c=a.getOption(b,"targetAddress",g.A1),d=new i;if(this._isInterpreting(c))return d;var e=a.getBooleanOption(b,"resolveNames",!1),f=e?this.hasRefTokens():this.hasToken("ref");if(!f)return d;b=this._extendWithOwnOptions(b);var h="",j=this._allTokens.every(function(a){switch(a.getType()){case"ref":var f=a.getRange3D(b);return f&&f.singleSheet()?(d.push(f),h+="R",!0):!1;case"name":var i=e?a.resolveNameModel(b.refSheet):null;if(!i)return!1;var j=_.clone(b);j.refAddress=g.A1;var k=this._lockInterpreting(c,function(){return i.getTokenArray().resolveRangeList(j)});return k.empty()?!1:(d.append(k),h+="R",!0);case"table":var l=e?a.getRange3D(c):null;return l?(d.push(l),h+="R",!0):!1;case"open":return h+="<",!0;case"close":return h+=">",!0;case"sep":return h+=",",!0;case"ws":return!0;default:return!1}},this);return j&&/^(R(,R)*|<R(,R)*>)$/.test(h)?d:d.clear()},f.prototype.extractRanges=function(b){var c=a.getOption(b,"targetAddress",g.A1),d=[];if(d.circular=!1,this._isInterpreting(c))return d.circular=!0,d;var e=a.getBooleanOption(b,"resolveNames",!1),f=e?this.hasRefTokens():this.hasToken("ref");return f?(b=this._extendWithOwnOptions(b),this._allTokens.forEach(function(a,f){switch(a.getType()){case"ref":var h=a.getRange3D(b);h&&d.push({range:h,index:f,type:"ref"});break;case"name":var i=e?a.resolveNameModel(b.refSheet):null;if(!i)return;var j=_.clone(b);j.refAddress=g.A1;var k=this._lockInterpreting(c,function(){return i.getTokenArray().extractRanges(j)});k.forEach(function(a){d.push({range:a.range,index:f,type:"name"})}),d.circular=d.circular||k.circular;break;case"table":var l=e?a.getRange3D(c):null;l&&d.push({range:l,index:f,type:"table"})}},this),d):d},f.prototype.resolveOperation=function(b,c){var d=this._resolveRefSheet(),e=null;switch(c.type){case"deleteSheet":return 0!==this._sheet3dTokens.length||this.hasToken("table")?this._resolveChangedFormula(b,function(a,b){return a.resolveDeletedSheet(b,c.sheet,d)}):null;case"renameSheet":return 0!==this._sheet3dTokens.length||this.hasToken("table")?this._resolveChangedFormula(b,function(a,b){return a.resolveRenamedSheet(b,c.sheet,c.sheetName,c.tableNames)}):null;case"relabelName":return 0===this._nameTokens.length?null:this._resolveChangedFormula(b,function(a,b){return a.resolveRelabeledName(b,c.sheet,c.oldLabel,c.newLabel,d)});case"moveCells":return this.hasToken("ref")||this.hasToken("table")?(e={refSheet:d,freezeRelRefs:this._freezeRelRefs},c.relocate&&(e.refAddress=c.relocate.from,e.targetAddress=c.relocate.to),this._resolveChangedFormula(b,function(a,b){return a.resolveMovedCells(b,c.sheet,c.moveDescs,e)})):null;case"cutPaste":return this.hasToken("ref")||this.hasToken("table")?(e={refSheet:d,sheet:c.sourceSheet},this._resolveChangedFormula(b,function(a,b){return a.resolveCutPasteCells(b,c.sourceRange,c.targetRange,e)})):null}return a.error('TokenArray.resolveOperation(): unknown operation type "'+c.type+'"'),null},f.prototype.registerChangeHandler=function(a){return(this._changeHandlers||(this._changeHandlers=[])).push(a),this},f.prototype.unregisterChangeHandler=function(a){return this._changeHandlers&&(this._changeHandlers=_.without(this._changeHandlers,a)),this},f.prototype.setTokens=function(a){return this.empty()&&0===a.length?this:(this._allTokens=a.slice(),this._refTokens=[],this._sheet3dTokens=[],this._tokenTypeSet={},this._allTokens.forEach(this._registerToken,this),this._invokeChangeHandlers(null),this)},f.prototype.clearTokens=function(){return this.setTokens([])},f.prototype.parseFormula=function(b,c,d){d=this._extendWithOwnOptions(d);var e=this._docModel.getFormulaParser(),f=e.parseFormula(b,c,d),g=_.pluck(f,"token");if(a.getBooleanOption(d,"autoCorrect",!1)){var h=this._compileTokens(g);if(!h.error)for(var i=0;i<h.missingClose;i+=1)g.push(new m(!1))}return this.setTokens(g),f},f.prototype.refreshAfterImport=function(a){return this.hasToken("bad")?this.parseFormula("op",this.getFormula("op"),a):this._sheet3dTokens.length>0&&(this._sheet3dTokens.forEach(function(a){a.refreshSheets()}),this._compileDesc=null,this.clearResultCache()),this},f.prototype.modifyToken=function(a,b,c,d){var e=this._allTokens[a];return e&&e.isType(b)&&c.call(d,e,a)&&this._invokeChangeHandlers(e,a),this},f.prototype.appendToken=function(a){return this._allTokens.push(a),this._registerToken(a),this._invokeChangeHandlers(a,this._allTokens.length-1),this},f.prototype.appendAddress=function(b,c){var d=a.getBooleanOption(c,"abs",!1),e=j.create(b,d,d),f=a.getIntegerOption(c,"sheet"),g="number"==typeof f?new k(f,!0):null;return this.appendToken(new n(this._docModel,e,null,g))},f.prototype.appendRange=function(b,c){var d=this._docModel.isColRange(b),e=this._docModel.isRowRange(b),f=a.getBooleanOption(c,"abs",!1),g=j.create(b.start,f||e,f||d&&!e),h=b.single()?null:j.create(b.end,f||e,f||d&&!e),i=a.getIntegerOption(c,"sheet"),l="number"==typeof i?new k(i,!0):null;return this.appendToken(new n(this._docModel,g,h,l))},f.prototype.appendRangeList=function(b,c){var d=b.length>1&&a.getBooleanOption(c,"parentheses",!1);return d&&this.appendToken(new m(!0)),b.forEach(function(a,b){b>0&&this.appendToken(new l),this.appendRange(a,c)},this),d&&this.appendToken(new m(!1)),this},f.prototype.relocateRanges=function(a,b){if(a.equals(b))return!1;var c=!1;return this._refTokens.forEach(function(d){d.relocateRange(a,b,this._wrapReferences)&&(c=!0)},this),c&&this._invokeChangeHandlers(null),c},f.prototype.transformSheet=function(a,b){if(b===a)return!1;var c=!1;return this._sheet3dTokens.forEach(function(d){d.transformSheet(a,b)&&(c=!0)},this),c&&this._invokeChangeHandlers(null),c},f.prototype.compileFormula=function(){return this._compileDesc||(this._compileDesc=this._compileTokens(this._allTokens))},f.prototype.getDependencies=function(a,b,e){var f={depRanges:new i,rootRanges:new i,names:{},tables:{},missingNames:{},missingFuncs:{},recalc:null,circular:!1},j=this.compileFormula();if(j.error)return f;var k=b instanceof g?b:null;if(this._isInterpreting(k||a))return f.circular=!0,f;_.extend(f.missingFuncs,j.missingFuncs),f.recalc=j.root.recalc,e=this._extendWithOwnOptions(e);var l=k?_.extend({},e,{refAddress:a,targetAddress:k}):null,m=k?null:h.get(b),n=function o(h){var j=h.token;if(j.isType("ref")){if(l){var n=j.getRange3D(l);return n?new i(n):null}return j.getExpandedRanges(a,m,e)}if(j.isType("name")){var p=j.resolveNameModel(e.refSheet);if(!p)return f.missingNames[c.getNameKey(j.getValue())]=!0,null;var q=this._lockInterpreting(k||a,function(){return p.getTokenArray().getDependencies(g.A1,b,e)});return f.depRanges.append(q.depRanges),f.names[p.getUid()]=p,_.extend(f.names,q.names),_.extend(f.tables,q.tables),_.extend(f.missingNames,q.missingNames),_.extend(f.missingFuncs,q.missingFuncs),f.recalc=d.getRecalcMode(f.recalc,q.recalc),f.circular=f.circular||q.circular,q.rootRanges}if(j.isType("table")){var r=j.resolveTableModel();if(!r)return null;f.tables[r.getUid()]=r;var s=j.getRange3D(k);return s?new i(s):null}if(h.operands&&h.signature){var t=new i;return h.signature.forEach(function(a,b){var c=o.call(this,h.operands[b]);switch(a.depSpec){case"pass":t.append(c);break;case"skip":break;default:f.depRanges.append(c)}},this),t}return null}.call(this,j.root);return f.rootRanges.append(n),f},f.prototype.interpretFormula=function(c,e){function f(){return i.interpretTokens(c,h.root,e)}var h=this.compileFormula(),i=this._docModel.getFormulaInterpreter();if(h.error)return i.createErrorResult(c,h.error);var j=a.getOption(e,"targetAddress",g.A1);if(this._isInterpreting(j))return i.createWarnResult(c,d.CIRCULAR_ERROR);e=this._extendWithOwnOptions(e);var k=e.cacheResult&&"always"!==h.root.recalc,l=k?this._resultCache||(this._resultCache=new b):null,m=function(){if(!l)return null;var a=this.hasToken("name"),b=a||h.root.relColRef,c=b&&e.refAddress?e.refAddress[0]:0,d=b?j[0]:0,f=a||h.root.relRowRef,i=f&&e.refAddress?e.refAddress[1]:0,k=f?j[1]:0;return g.key(c,i)+":"+g.key(d,k)}.call(this);return this._lockInterpreting(j,function(){return l?l.getOrCreate(m,f):f()})},f.prototype.clearResultCache=function(){return this._resultCache=null,this},f});