define("io.ox/office/spreadsheet/model/model",["io.ox/office/tk/utils","io.ox/office/tk/utils/iteratorutils","io.ox/office/tk/container/simplemap","io.ox/office/tk/locale/localedata","io.ox/office/editframework/model/editmodel","io.ox/office/editframework/model/viewattributesmixin","io.ox/office/spreadsheet/utils/config","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/utils/operationcontext","io.ox/office/spreadsheet/model/operationsgenerator","io.ox/office/spreadsheet/model/numberformatter","io.ox/office/spreadsheet/model/namecollection","io.ox/office/spreadsheet/model/listcollection","io.ox/office/spreadsheet/model/sheetmodel","io.ox/office/spreadsheet/model/modelattributesmixin","io.ox/office/spreadsheet/model/formula/parser/formularesource","io.ox/office/spreadsheet/model/formula/parser/formulagrammar","io.ox/office/spreadsheet/model/formula/parser/formulaparser","io.ox/office/spreadsheet/model/formula/interpret/formulacompiler","io.ox/office/spreadsheet/model/formula/interpret/formulainterpreter","io.ox/office/spreadsheet/model/formula/deps/dependencymanager"],function(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){"use strict";function w(w){function F(a,b){ma[0]=a-1,ma[1]=b-1}function G(a){return a=_.isNumber(a)?a:_.isString(a)?Z.getSheetIndex(a):-1,a>=0&&a<ba.length?ba[a]:null}function H(a,b){var c=Z.getSheetModel(a),d=_.isNumber(b)?Z.getSheetModel(b):null;return 0===a.length?"sheet:name:empty":/^'|[\x00-\x1f\x80-\x9f[\]*?:/\\]|'$/.test(a)?"sheet:name:invalid":!_.isObject(c)||_.isObject(d)&&c===d?null:"sheet:name:used"}function I(a,b){return null===H(a,b)}function J(a,b){var c=H(a,b);return null===c?$.when():i.makeRejected(c)}function K(a,b,c,d){if(Z.getSheetCount()===g.MAX_SHEET_COUNT)return null;var e=new o(Z,b,d);return Z.trigger("insert:sheet:before",a),a<ba.length&&ca.clear(),ba.splice(a,0,{model:e,name:c}),Z.trigger("insert:sheet:after",a,e),Z.trigger("transform:sheet",null,a),Z.listenTo(e,"triggered",function(a,b){var c=D[b]||b;Z.trigger.apply(Z,[c,e.getIndex()].concat(_.toArray(arguments).slice(2)))}),e}function L(a){var b=a.getInt("sheet"),c=a.getStr("sheetName"),d=a.getOptEnum("type",/^(work|chart|macro|dialog)sheet$/,"worksheet"),e=a.getOptObj("attrs");a.ensure(!E,"debug mode: insert sheet fails"),a.ensure(b>=0&&b<=Z.getSheetCount(),"invalid sheet index"),a.ensure(I(c),"invalid sheet name");var f=K(b,d,c,e);a.ensure(f,"cannot create sheet")}function M(a,b,c){a.ensure(Z.getSheetCount()>1,"cannot delete last sheet"),Z.trigger("delete:sheet:before",c,b),b.destroy(),ba.splice(c,1),c<ba.length&&ca.clear(),Z.trigger("delete:sheet:after",c),Z.trigger("transform:sheet",c,null)}function N(a,b,c){var d=G(c),e=a.getStr("sheetName");a.ensure(I(e,c),"invalid sheet name"),d.name!==e&&(d.name=e,Z.trigger("rename:sheet",c,e,b))}function O(a,b,c){var d=a.getInt("to");a.ensure(d>=0&&d<=Z.getSheetCount(),"invalid target index");var e=ba[c];Z.trigger("move:sheet:before",c,d,b),ba.splice(c,1),ba.splice(d,0,e),ca.clear(),Z.trigger("move:sheet:after",c,d,b),Z.trigger("transform:sheet",c,d)}function P(a,b){var c=a.getInt("to");a.ensure(c>=0&&c<=Z.getSheetCount(),"invalid target index");var d=a.getStr("sheetName");a.ensure(I(d),"invalid sheet name");var e=K(c,b.getType(),d);a.ensure(e,"cannot create sheet"),e.applyCopySheetOperation(a,b)}function Q(a){if(0===arguments.length){var b=Z.getActiveSheet(),c=Z.getSheetModel(b);return c?{sheet:b,selection:c.getViewAttribute("selection")}:null}var d=Z.getSheetModel(a.sheet);d&&(Z.setActiveSheet(a.sheet),d.setViewAttribute("selection",a.selection))}function R(a){var b=a.filter(function(a){return a.remote&&_.isObject(a.userData)&&_.isNumber(a.userData.sheet)&&_.isString(a.userData.ranges)});Z.setViewAttribute("remoteClients",b)}function S(a,b,c){Z.registerContextOperationHandler(a,function(a){b[c](a)})}function T(b,c,d){var e=a.getBooleanOption(d,"allowDoc",!1);return Z.registerContextOperationHandler(b,function(a){var b=e&&!a.has("sheet"),d=b?null:a.getInt("sheet"),f=b?Z:Z.getSheetModel(d);return a.ensure(f,"missing sheet"),c.call(Z,a,f,d)})}function U(a,b,c){T(a,function(a,c){c[b](a)},c)}function V(a,b,c,d){T(a,function(a,d){d[b]()[c](a)},d)}function W(a,b){return Z.registerContextOperationHandler(a,function(a){var c=a.getArr("start");a.ensure(c.length>=2&&c.every(_.isNumber),"invalid drawing position");var d=Z.getSheetModel(c[0]);return a.ensure(d,"missing sheet"),b.call(Z,a,d.getDrawingCollection(),c.slice(1))})}function X(a,b){W(a,function(a,c,d){c[b](a,d)})}function Y(a,b,c){W(a,function(a,d,e){var f=d.findModel(e,{deep:!0,type:c});a.ensure(f,"invalid drawing position"),f[b](a)})}var Z=this,aa=w.getFileFormat(),ba=[],ca=new c,da=new c,ea=new c,fa=null,ga=null,ha=null,ia=null,ja=null,ka=null,la=null,ma=x.A1.clone(),na=[];e.call(this,w,{generatorClass:k,contextClass:j,selectionStateHandler:Q});var oa=this.createDebouncedMethod(_.noop,function(){var a=Q();a&&w.updateUserData({sheet:a.sheet,ranges:ha.formatRangeList("op",a.selection.ranges),drawings:a.selection.drawings})},{delay:250,infoString:"Model: sendActiveSelectionDebounced",app:w});this.postProcessImport=function(){return 0===this.getSheetCount()?$.Deferred().reject():(this.getCellStyles().createMissingStyles(),this.iterateSliced(this.createSheetIterator(),function(a){return a.postProcessImport()},{infoString:"SpreadsheetModel.postProcessImport()",app:w}))},this._registerTableModel=function(a){a.isAutoFilter()||da.insert(a.getKey(),a)},this._unregisterTableModel=function(a){a.isAutoFilter()||da.remove(a.getKey())},this.getNumberFormatter=function(){return fa},this.getFormulaResource=function(){return q.create(aa,d.LOCALE)},this.getFormulaGrammar=function(a){return ea.getOrCreate(a,function(){var b=a.split("!"),c=b[1]?"rc"===b[1]:this.getViewAttribute("rcStyle"),d=b[0].split(":"),e=d[1]||aa;return r.create(d[0],e,c)},this)},this.getFormulaParser=function(){return ha},this.getFormulaCompiler=function(){return ia},this.getFormulaInterpreter=function(){return ja},this.getNameCollection=function(){return ka},this.getListCollection=function(){return la},this.getDependencyManager=function(){return ga},this.getMaxCol=function(){return ma[0]},this.getMaxRow=function(){return ma[1]},this.getMaxIndex=function(a){return ma.get(a)},this.getMaxAddress=function(){return ma.clone()},this.getSheetRange=function(){return z.createFromAddresses(x.A1,ma)},this.isColRange=function(a){return 0===a.start[1]&&a.end[1]===ma[1]},this.makeColRange=function(a){return z.create(_.isNumber(a)?a:a.first,0,_.isNumber(a)?a:a.last,ma[1])},this.makeColRanges=function(a){return A.map(a,this.makeColRange.bind(this))},this.isRowRange=function(a){return 0===a.start[0]&&a.end[0]===ma[0]},this.makeRowRange=function(a){return z.create(0,_.isNumber(a)?a:a.first,ma[0],_.isNumber(a)?a:a.last)},this.makeRowRanges=function(a){return A.map(a,this.makeRowRange.bind(this))},this.isFullRange=function(a,b){return b?this.isColRange(a):this.isRowRange(a)},this.makeFullRange=function(a,b){return b?this.makeColRange(a):this.makeRowRange(a)},this.makeFullRanges=function(a,b){return b?this.makeColRanges(a):this.makeRowRanges(a)},this.isValidAddress=function(a){return a[0]>=0&&a[0]<=ma[0]&&a[1]>=0&&a[1]<=ma[1]},this.isValidRange=function(a){return a.start[0]>=0&&a.start[0]<=a.end[0]&&a.end[0]<=ma[0]&&a.start[1]>=0&&a.start[1]<=a.end[1]&&a.end[1]<=ma[1]},this.createInterval=function(a,b,c){if(!_.isObject(a))return null;var d=c?"start":"first",e=c?"end":"last",f=this.getMaxIndex(b),g=a[d];if(!_.isNumber(g)||!isFinite(g)||0>g||g>f)return null;if(!(e in a))return new y(g);var h=a[e];return!_.isNumber(h)||!isFinite(h)||g>h||h>f?null:new y(g,h)},this.createAddress=function(a){return _.isArray(a)&&2===a.length?!_.isNumber(a[0])||!isFinite(a[0])||a[0]<0||a[0]>ma[0]?null:!_.isNumber(a[1])||!isFinite(a[1])||a[1]<0||a[1]>ma[1]?null:new x(a[0],a[1]):null},this.createRange=function(a){if(!_.isObject(a))return null;var b=this.createAddress(a.start);if(!b)return null;if(!("end"in a))return new z(b);var c=this.createAddress(a.end);return!c||c[0]<b[0]||c[1]<b[1]?null:new z(b,c)},this.createRangeArray=function(a){if(!_.isArray(a)||0===a.length)return null;var b=new A;return a.every(function(a){return a=this.createRange(a),a?(b.push(a),!0):void 0},this),a.length===b.length?b:null},this.getBoundedMovedRange=function(b,c,d){return c=a.minMax(c,-b.start[0],ma[0]-b.end[0]),d=a.minMax(d,-b.start[1],ma[1]-b.end[1]),z.create(b.start[0]+c,b.start[1]+d,b.end[0]+c,b.end[1]+d)},this.getCroppedMovedRange=function(a,b,c){var d=Math.max(0,a.start[0]+b),e=Math.max(0,a.start[1]+c),f=Math.min(ma[0],a.end[0]+b),g=Math.min(ma[1],a.end[1]+c);return f>=d&&g>=e?z.create(d,e,f,g):null},this.getMaxSheetNameLength=function(){return w.isOOXML()?31:65535},this.getSheetCount=function(){return ba.length},this.getSheetNames=function(){return _.pluck(ba,"name")},this.hasSheet=function(a){return _.isObject(G(a))},this.getSheetName=function(a){var b=G(a);return b?b.name:null},this.getSheetIndex=function(b){return b=b.toLowerCase(),a.findFirstIndex(ba,function(a){return a.name.toLowerCase()===b})},this.getSheetIndexOfModel=function(b){return ca.getOrCreate(b.getUid(),function(){return a.findFirstIndex(ba,function(a){return a.model===b})})},this.getSheetModel=function(a){var b=G(a);return b?b.model:null},this.createSheetIntervalIterator=function(c,d,e){var f=b.createArrayIterator(ba,{begin:c,end:d+1}),g=a.getTokenListOption(e,"types",null),h=g?a.makeSet(g):null,i=a.getBooleanOption(e,"visible",null);return b.createTransformIterator(f,function(a,b){var c=a.model,d=!h||c.getType()in h;return d&&(d=null===i||i===a.model.getMergedAttributeSet(!0).sheet.visible),d?{value:a.model,name:a.name,sheet:b.index}:null})},this.createSheetIterator=function(a){return this.createSheetIntervalIterator(0,ba.length-1,a)},this.getActiveSheet=function(){return this.getViewAttribute("activeSheet")},this.setActiveSheet=function(a){return this.setViewAttribute("activeSheet",a)},this.generateUnusedSheetName=function(){for(var a="",b=this.getSheetCount();0===a.length||this.hasSheet(a);)a=i.getSheetName(b),b+=1;return a},this.hasName=function(a){return ka.hasName(a)||ba.some(function(b){return b.model.getNameCollection().hasName(a)})},this.getAllNames=function(b){var c=ka.getAllNames(b);return a.getBooleanOption(b,"skipLocal",!1)||ba.forEach(function(a){c=c.concat(a.model.getNameCollection().getAllNames(b))}),c},this.hasTable=function(a){return da.has(i.getTableKey(a))},this.getTable=function(a){return da.get(i.getTableKey(a),null)},this.getAllTables=function(a){return ba.reduce(function(b,c){return b.concat(c.model.getTableCollection().getAllTables(a))},[])},this.getRangeContents=function(b,c){var d=a.getIntegerOption(c,"maxCount",null,1),e=[];return e.count=0,b=B.filter(b,function(b){return this.hasSheet(b.sheet1)&&b.singleSheet()?!0:(a.warn("SpreadsheetModel.getRangeContents(): invalid sheet index in range address"),!1)},this),c=_.clone(c),B.forEach(b,function(b){var f=this.getSheetModel(b.sheet1).getCellCollection(),g=b.toRange(),h=f.getRangeContents(g,c);return e=e.concat(h),e.count+=h.count,d===e.count?a.BREAK:void(d&&(c.maxCount-=h.count))},this),e},this.sendOperations=_.wrap(this.sendOperations,function(b,c,d){return a.getBooleanOption(d,"defer",!1)?(na=na.concat(k.getArray(c,d)),!0):b.call(this,c,d)}),this.createAndApplyOperations=i.profileAsyncMethod("SpreadsheetModel.createAndApplyOperations()",_.wrap(this.createAndApplyOperations,function(a,b,c){return na.length>0&&(this.sendOperations(na),na=[]),a.call(this,function(a){return b.call(this,a).always(function(){a.logCacheUsage()})},_.extend({applyImmediately:!0},c))})),this.generateOperationsForAllSheets=function(b,c,d){var e=b.getSheetIndex(),f=a.getIntegerOption(d,"skipSheet",null),g=this.iterateSliced(this.createSheetIterator(d),function(a,d){return d.sheet!==f?(b.setSheetIndex(d.sheet),c.call(Z,a,d.sheet)):void 0},{delay:"immediate",infoString:"Model: generateOperationsForAllSheets",app:w});return g.done(function(){b.setSheetIndex(e)})},this.generateUpdateFormulaOperations=function(a,b,c){var d=ka.generateUpdateFormulaOperations(a,b);return d=d.then(function(){return Z.generateOperationsForAllSheets(a,function(c){return c.generateUpdateFormulaOperations(a,b)},c)})},this.generateInsertSheetOperations=function(a,b,c,d){return J(c).then(function(){var e={sheet:b,sheetName:c};_.isObject(d)&&(e.attrs=d),a.setSheetIndex(b),a.generateSheetOperation(h.DELETE_SHEET,null,{undo:!0,prepend:!0}),a.generateSheetOperation(h.INSERT_SHEET,{sheetName:c})})},this.generateDeleteSheetOperations=function(a,b){var c={type:"deleteSheet",sheet:b},d=this.generateUpdateFormulaOperations(a,c,{skipSheet:b});return d=d.then(function(){return a.setSheetIndex(b),Z.getSheetModel(b).generateRestoreOperations(a)}),d.done(function(){a.setSheetIndex(b),a.generateSheetOperation(h.DELETE_SHEET)})},this.generateMoveSheetOperations=function(a,b,c){return a.setSheetIndex(c).generateSheetOperation(h.MOVE_SHEET,{to:b},{undo:!0,prepend:!0}),a.setSheetIndex(b).generateSheetOperation(h.MOVE_SHEET,{to:c}),$.when()},this.generateCopySheetOperations=function(a,b,c,d){return J(d).then(function(){var e={};Z.getAllTables().forEach(function(a){e[a.getKey()]=!0});var f=Z.getSheetModel(b),g={};f.getTableCollection().getAllTables().forEach(function(a){for(var b=a.getName(),c=/^(.*?)(\d+)$/.exec(b),d=c?c[1]:i.getTableName(),f=c?parseInt(c[2],10)+1:1;i.getTableKey(d+f)in e;)f+=1;var h=d+f;e[i.getTableKey(h)]=!0,g[b]=h});var j={to:c,sheetName:d,tableNames:g};a.setSheetIndex(b).generateSheetOperation(h.COPY_SHEET,j);var k=Z.getSheetModel(c),l={type:"renameSheet",sheet:b,sheetName:d,tableNames:g};a.setSheetIndex(c);var m=k.generateUpdateFormulaOperations(a,l);return m.done(function(){a.clearOperations({undo:!0}),a.generateSheetOperation(h.DELETE_SHEET,null,{undo:!0})})})},this.generateRenameSheetOperations=function(a,b,c){var d=this.getSheetName(b);return d===c?$.when():J(c,b).then(function(){var e=Z.createOperationsGenerator(),f={type:"renameSheet",sheet:b,sheetName:c},g=Z.generateUpdateFormulaOperations(e,f);return g.done(function(){a.setSheetIndex(b),a.generateSheetOperation(h.RENAME_SHEET,{sheetName:d},{undo:!0}),a.generateSheetOperation(h.RENAME_SHEET,{sheetName:c}),a.appendOperations(e,{undo:!0}),a.appendOperations(e)})})},f.call(this,C),fa=new l(this),ga=new v(this),ha=new s(this),ia=new t(this),ja=new u(this),ka=new m(this),la=new n(this),p.call(this),"ooxml"===aa&&(S(h.INSERT_NUMBER_FORMAT,fa,"applyInsertOperation"),S(h.DELETE_NUMBER_FORMAT,fa,"applyDeleteOperation")),this.registerContextOperationHandler(h.INSERT_SHEET,L),T(h.DELETE_SHEET,M),T(h.RENAME_SHEET,N),T(h.MOVE_SHEET,O),T(h.COPY_SHEET,P),U(h.CHANGE_SHEET,"applyChangeSheetOperation"),V(h.CHANGE_CELLS,"getCellCollection","applyChangeCellsOperation"),V(h.INSERT_CELLS,"getCellCollection","applyInsertCellsOperation"),V(h.DELETE_CELLS,"getCellCollection","applyDeleteCellsOperation"),V(h.INSERT_HYPERLINK,"getHyperlinkCollection","applyInsertHyperlinkOperation"),V(h.DELETE_HYPERLINK,"getHyperlinkCollection","applyDeleteHyperlinkOperation"),V(h.MERGE_CELLS,"getMergeCollection","applyMergeCellsOperation"),V(h.INSERT_COLUMNS,"getColCollection","applyInsertOperation"),V(h.DELETE_COLUMNS,"getColCollection","applyDeleteOperation"),V(h.CHANGE_COLUMNS,"getColCollection","applyChangeOperation"),V(h.INSERT_ROWS,"getRowCollection","applyInsertOperation"),V(h.DELETE_ROWS,"getRowCollection","applyDeleteOperation"),V(h.CHANGE_ROWS,"getRowCollection","applyChangeOperation"),V(h.INSERT_NAME,"getNameCollection","applyInsertOperation",{allowDoc:!0}),V(h.DELETE_NAME,"getNameCollection","applyDeleteOperation",{allowDoc:!0}),V(h.CHANGE_NAME,"getNameCollection","applyChangeOperation",{allowDoc:!0}),V(h.INSERT_TABLE,"getTableCollection","applyInsertOperation"),V(h.DELETE_TABLE,"getTableCollection","applyDeleteOperation"),V(h.CHANGE_TABLE,"getTableCollection","applyChangeOperation"),V(h.CHANGE_TABLE_COLUMN,"getTableCollection","applyChangeColumnOperation"),V(h.INSERT_VALIDATION,"getValidationCollection","applyInsertOperation"),V(h.DELETE_VALIDATION,"getValidationCollection","applyDeleteOperation"),V(h.CHANGE_VALIDATION,"getValidationCollection","applyChangeOperation"),V(h.INSERT_CFRULE,"getCondFormatCollection","applyInsertOperation"),V(h.DELETE_CFRULE,"getCondFormatCollection","applyDeleteOperation"),V(h.CHANGE_CFRULE,"getCondFormatCollection","applyChangeOperation"),X(h.INSERT_DRAWING,"applyInsertDrawingOperation"),X(h.DELETE_DRAWING,"applyDeleteDrawingOperation"),Y(h.SET_DRAWING_ATTRIBUTES,"applySetAttributesOperation"),Y(h.INSERT_CHART_DATASERIES,"applyInsertSeriesOperation","chart"),Y(h.DELETE_CHART_DATASERIES,"applyDeleteSeriesOperation","chart"),Y(h.SET_CHART_DATASERIES_ATTRIBUTES,"applyChangeSeriesOperation","chart"),Y(h.SET_CHART_AXIS_ATTRIBUTES,"applyChangeAxisOperation","chart"),Y(h.SET_CHART_GRIDLINE_ATTRIBUTES,"applyChangeGridOperation","chart"),Y(h.SET_CHART_TITLE_ATTRIBUTES,"applyChangeTitleOperation","chart"),Y(h.SET_CHART_LEGEND_ATTRIBUTES,"applyChangeLegendOperation","chart"),this.listenTo(ka,"triggered",function(a,b){Z.trigger.apply(Z,[b,null].concat(_.toArray(arguments).slice(2)))}),F(this.getDocumentAttribute("cols"),this.getDocumentAttribute("rows")),this.on("change:attributes",function(a,b){F(b.cols,b.rows)}),this.on("change:viewattributes",function(a,b){"activeSheet"in b&&oa()}),this.on("change:sheet:viewattributes",function(a,b,c){"selection"in c&&b===Z.getActiveSheet()&&oa()}),this.listenTo(w,"docs:users:selection",R),this.registerDestructor(function(){_.chain(ba).pluck("model").invoke("destroy"),ka.destroy(),la.destroy(),ja.destroy(),ia.destroy(),ha.destroy(),ga.destroy(),fa.destroy(),ba=ca=da=ea=null,ha=ia=ja=null,ga=fa=ka=la=w=null})}var x=i.Address,y=i.Interval,z=i.Range,A=i.RangeArray,B=i.Range3DArray,C={activeSheet:{def:-1,validate:function(b){return b>=-1&&b<this.getSheetCount()?b:a.BREAK}},rcStyle:{def:!1},remoteClients:{def:[],validate:function(a){return _.isArray(a)?a:[]}},highlightFormulas:{def:!1}},D={"change:attributes":"change:sheet:attributes","change:viewattributes":"change:sheet:viewattributes"},E=g.getDebugUrlFlag("spreadsheet:failing-import");return e.extend({constructor:w})});